{
	FreeWinRally - Un programma per ricevere via packet i tempi dei rally
	Copyright (C) 2000, 2001, 2002 Sezione ARI Casale Monferrato & I1EPJ

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}
unit Rally;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
	Forms, Dialogs, Grids, StdCtrls, Menus, About, Config, GNULic, UFine,
	ExtCtrls, Printers, Fogli, Displog, Aiuto, UCall, UPrev, UClass, UStartup;

{
	Costanti assortite (stati e comandi)
}
const
	WaitStrSWorCmd = 0;
	WaitCmd        = 1;
	ReadData       = 2;
	ReadMsg	       = 3;
	ReadNotes      = 4;
	EndFrame       = 5;
	UpdateConns	   = 6;

	StartCmd  = '$';
	CmdData   = 'T';
	CmdNotes  = 'N';
	CmdMsg    = 'M';
	CmdPnlty  = 'P';
	CmdStream = '|';
	CmdTimer  = '#';
   CmdDisc   = 'D';

	EndCmd    = chr(1);

	NULL  = chr(0);
	SOH	  = chr(1);
   CTRLC = chr(3);
	BELL  = chr(7);
	TAB   = chr(9);
	LF    = chr(10);
	CR    = chr(13);
	SPACE = ' ';

   Separators = [' ',CR,LF,TAB,':',';','.',',','-','''','"'];

	CronoFmt = '%s%2.2d%2.2d%2.2dxx#%3.3dH%2.2d:%2.2d''%2.2d.%2.2d';

	RxBufSize = 4096;
	TxBufSize = 4096;

	TIMEOUT      = 15/86400;	{15''}
	LINE_TIMEOUT = 5/864000; 	{500 ms}

   ALLPS = MAXINT;

   DefaultFont = 'Times New Roman';

type
	TFRally = class(TForm)
		BStampa: TButton;
		Stazioni: TStringGrid;
		Tempi: TStringGrid;
		MainMenu1: TMainMenu;
		Conf1: TMenuItem;
		TxBuf: TEdit;
		RxBuf: TMemo;
		Label4: TLabel;
		File1: TMenuItem;
		Escidalprogramma1: TMenuItem;
		Informazionisu1: TMenuItem;
		Info: TMenuItem;
		BAggiorna: TButton;
		Label5: TLabel;
		Label1: TLabel;
		Note: TStringGrid;
		Log1: TMenuItem;
		Seleziona: TMenuItem;
		Label2: TLabel;
		DataOra: TLabel;
		Timer1: TTimer;
		LPSnum: TLabel;
		LTime: TLabel;
		LFgnum: TLabel;
		PrintDialog1: TPrintDialog;
		Stampante1: TMenuItem;
		Programma1: TMenuItem;
		GNUlic: TMenuItem;
		Man: TMenuItem;
		Label3: TLabel;
		Apri1: TMenuItem;
		AprifileLog1: TMenuItem;
		ApriFile: TOpenDialog;
		Log2: TMenuItem;
		Visualizza1: TMenuItem;
		PopupConn: TPopupMenu;
		Conn: TMenuItem;
		Disc: TMenuItem;
		Annulla: TMenuItem;
		BStampaM: TButton;
		FontDialog1: TFontDialog;
		AnteprimadiStampa1: TMenuItem;
    	Classifica1: TMenuItem;
    	Generale1: TMenuItem;
    	DiClasse1: TMenuItem;
		N1: TMenuItem;
		N2: TMenuItem;
		N3: TMenuItem;
		ApriRally1: TMenuItem;
		N4: TMenuItem;
		SalvaRally1: TMenuItem;
		SaveRally: TSaveDialog;
		Azzera1: TMenuItem;
		N5: TMenuItem;
		NuovoRally1: TMenuItem;
    	DiClassePS: TMenuItem;
    	N6: TMenuItem;
    	GeneralePS: TMenuItem;
    	dellaPS1: TMenuItem;
    InviaAiCrono: TButton;
    Aggiornaelencofogli1: TMenuItem;
    N8: TMenuItem;
    diclassedellaPS1: TMenuItem;
		procedure InfoClick(Sender: TObject);
		procedure Escidalprogramma1Click(Sender: TObject);
		procedure FormCreate(Sender: TObject);
		procedure Timer1Timer(Sender: TObject);
		procedure AppMessage(var Msg: TMsg; var Handled: Boolean);
		procedure TxBufKeyPress(Sender: TObject; var Key: Char);
		procedure Programma1Click(Sender: TObject);
		procedure Stampante1Click(Sender: TObject);
		procedure BStampaClick(Sender: TObject);
		procedure FormResize(Sender: TObject);
		procedure TxBufKeyDown(Sender: TObject; var Key: Word;
						Shift: TShiftState);
		procedure GNUlicClick(Sender: TObject);
		procedure FormClose(Sender: TObject; var Action: TCloseAction);
		function FindPS(Call:string): integer;
		procedure StazioniClick(Sender: TObject);
		procedure SelezionaClick(Sender: TObject);
		procedure ManClick(Sender: TObject);
		procedure StampaFoglio(UnFoglio: TFoglio; StampaMedie, Anteprima:Boolean);
		procedure CancellaDisplay;
		procedure VisualizzaFoglio(Foglio: TFoglio);
		procedure BAggiornaClick(Sender: TObject);
		procedure Apri1Click(Sender: TObject);
		procedure AprifileLog1Click(Sender: TObject);
		procedure Visualizza1Click(Sender: TObject);
		procedure DiscClick(Sender: TObject);
		procedure ConnClick(Sender: TObject);
		procedure BStampaMClick(Sender: TObject);
		procedure AnteprimadiStampa1Click(Sender: TObject);
  		procedure Disconnect(channel: char);
		procedure ByeBye(channel: char);
		procedure EvidenziaStazione(channel: char);
		procedure Generale1Click(Sender: TObject);
		procedure DiClasse1Click(Sender: TObject);
		procedure AggiornaClassifica(Foglio: TFoglio);
		procedure RicostruisciClassifica(PSNum: integer);
		procedure OrdinaClassifica(NumPS: integer);
		procedure VisualizzaClassifica(Classe: string; NumPS: integer);
       function ContaPS(var MinPS:integer; var MaxPS: integer): integer;
    	procedure SalvaRally1Click(Sender: TObject);
    	procedure ApriRally1Click(Sender: TObject);
    	procedure Azzera1Click(Sender: TObject);
		procedure CostruisciMenuClasse;
		procedure CostruisciMenuConnetti;
		procedure CostruisciMenuPSMenuClassi;
		procedure NuovoRally1Click(Sender: TObject);
		procedure CostruisciMenuPS;
		procedure GeneralePSClick(Sender: TObject);
		procedure DiClassePSClick(Sender: TObject);
    	procedure dellaps1click(Sender: TObject);
	    procedure InviaFoglioAiCrono(Foglio: TFoglio);
    procedure InviaAiCronoClick(Sender: TObject);
    procedure Aggiornaelencofogli1Click(Sender: TObject);
 {
		Cosa nostra, aaah
 }
		private
			{ Private declarations }
			hOldFont, hFont: hFont;
			procedure ParseRx(buf: PChar);
			procedure ParseData(buf: PChar);
			procedure UpdateConn;
       	function CalcolaMedia(Foglio:TFoglio; n:integer): single;

 		{
			Il pubblico non  ammesso
		}
		public
		{ Public declarations }
	end;

{
	Qualche variabile globale randagia.
	Le altre sono definite nell'unit CONFIG.
}
var
	FRally: TFRally;
	RxBuffer: array[0..512] of char;
	State,Row,Ret,NoteLine,Errore: integer;
	LastStream: char;
	LastCall: string[20];
	LastPS: integer;
	PNote: array[0..40] of char;
	tim,DeltaT: TDateTime;
	StartTime,t: TDateTime;
	ConnMenu: array[0..50] of TMenuItem;
	MenuClassi1: array[0..50] of TMenuItem;
	MenuClassi2: array[0..50] of TMenuItem;
   MenuPS1: array[0..50] of TMenuItem;
   MenuPS2: array[0..50] of TMenuItem;
	s: string;
	OH, OW: Longint;
	Xs: array[1..40] of Longint;
	Ys: array[1..40] of Longint;
	Ws: array[1..40] of Longint;
	Hs: array[1..40] of Longint;
	Wt: array[0..20] of Integer;
	Ht: Integer;
	Wc: array[0..20] of Integer;
	Hc: Integer;
	Wn: array[0..20] of Integer;
	Hn: Integer;
	PrevHeight, PrevWidth: longint;
	Toggle, done: Boolean;
   COMAvailable: array[1..9] of string[4];
	n,ComP: integer;
   COMName: PChar;

implementation

{$R *.DFM}

{
	Inizializzazioni assortite da fare alla partenza.
	Altre che non richiedono di accedere ai vari oggetti
	sono nella sezione Initialization.
}
procedure TFRally.FormCreate(Sender: TObject);

var dcb: TDCB;
	s: string;
	pch: PChar;
	Ret,i: Integer;
	Lspeed: longint;
	buf: array[0..80] of char;

begin
	{ Metti qualche titolo qua e l }
	FRally.Caption := 'FreeWinRally '+ PrgVers + ' - ' + Conf.RallyData.NomeRally;
	with Tempi do begin
		Cells[0,0] := 'C#';
		Cells[1,0] := 'Tempo';
		Cells[2,0] := 'Km/h';
		Cells[3,0] := 'Note';
		TopRow := 2;
	end;
	with Stazioni do begin
		Cells[0,0] := 'P.S.';
		Cells[1,0] := 'Can.';
		Cells[2,0] := 'Nominativo';
		TopRow := 1;
	end;

   { Ricostruisce la classifica }
   RicostruisciClassifica(ALLPS);

	{ Costruisce il sottomen Connetti }
	CostruisciMenuConnetti;

	{ Costruisce il sottomen Di Classe }
	CostruisciMenuClasse;

	{ Inizializza la data e l'ora }
	s := FormatDateTime('dd/mm hh":"nn"', now);
	DataOra.Caption := s;
	Note.TopRow := 1;

	{ Se il file Quaderno contiene fogli, visualizza l'ultimo }
	if FileSize(Quaderno) > 0 then begin
		Seek(Quaderno, FileSize(Quaderno) - 1);
		Read(Quaderno, Foglio);
		VisualizzaFoglio(Foglio);
	end;

	{ Se arriva un messaggio, mandalo al segretario AppMessage }
	Application.OnMessage := AppMessage;

	{
	  Inizializzazioni per ridimensionamento componenti e font.

	  Copiato bovinamente da un esempio di Ari Hirviniemi.
	  I commenti sono quelli originali dell'Autore.

	  Save original window size and components size and positions for
	  later calculations. Warning: here's fixed array and it's supposed
	  that no component is created or deleted at run-time. There is
	  more elegant solutions but this is just for simplicity.
	}

	 for i := 0 to ComponentCount - 1 do
			if Components[i] is TControl then begin
	  		Xs[i] := TControl(Components[i]).Left;
			Ys[i] := TControl(Components[i]).Top;
	  		Ws[i] := TControl(Components[i]).Width;
	  		Hs[i] := TControl(Components[i]).Height;
	 end;
	 for i := 0 to Tempi.ColCount-1 do
	  		Wt[i] := Tempi.ColWidths[i];

	 Ht := Tempi.DefaultRowHeight;

	 for i := 0 to Note.ColCount-1 do
			Wn[i] := Note.ColWidths[i];

	 Hn := Note.DefaultRowHeight;

	 for i := 0 to Stazioni.ColCount-1 do
			Wc[i] := Stazioni.ColWidths[i];

	 Hc := Stazioni.DefaultRowHeight;

	 {
	  Scale window so that it's size compared to screen size is same
	  as designed. Note that divisors here are your desing-time
	  screen dimensions.
	 }
	 OH := ClientHeight;
	 OW := ClientWidth;
	 Height := Screen.Height-1;
	 Width := Screen.Width-1;

	 {
	  Apertura della stalla, cio, volevo dire, della porta seriale verso il TNC
	 }
	 repeat
		if PortNum >= 0 then CloseComm(PortNum);
		PortNum := OpenComm(PortName, RxBufSize, TxBufSize);
	  	if PortNum >= 0 then begin
			StrCopy(buf,PortName);
	 		StrCat(buf,PortSpeed);
	 		StrCat(buf,PortParity);
	 		StrCat(buf,PortBits);
	 		StrCat(buf,PortStops);
       	if BuildCommDCB(buf, dcb) < 0 then begin
				Ret := Application.MessageBox(DCBError,'Errore!' , MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
           	if Ret = IDABORT then Halt;
       	end;
			dcb.Flags := dcb_Binary;
			if PortHand = 0 then begin
				dcb.Flags := dcb.Flags or dcb_OutxCtsFlow or dcb_Rtsflow;
			end else begin
				dcb.Flags := dcb.Flags or dcb_OutX or dcb_InX;
		 	end;
			SetCommState(dcb);
			EnableCommNotification(PortNum,FRally.Handle,256,-1);
			{
			  Siamo riusciti, nessuno sa come, ad aprire la porta seriale.
			  Mandiamo una raffica di comandi di inizializzazione al TNC.
			}
			ConfForm.InitTNC(Conf.TNCInitI, TNCType);
		end else begin
			StrFmt(buf, 'Non posso aprire %s (Errore #%d)',[PortName,-PortNum]);
			Ret := Application.MessageBox(buf,'Errore!' , MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
			if (Ret = IDABORT) then begin
				Halt;
			end;
		end;
	 until (PortNum >= 0) OR (Ret = IDIGNORE);

	{
	 Apertura della porta seriale verso i cronometristi
	}
	if CronoPortNameI > 0 then begin
		StrCopy(buf, CronoPortName);
		StrCat(buf,',2400');
		StrCat(buf,',N');
		StrCat(buf,',8');
		StrCat(buf,',2');
		repeat
				CronoPortNum := OpenComm(CronoPortName, RxBufSize, TxBufSize);
				if CronoPortNum >= 0 then begin
				  BuildCommDCB(buf, dcb);
				  dcb.Flags := dcb_Binary or dcb_OutX or dcb_InX;
				  SetCommState(dcb);
			   end else begin
				   StrFmt(buf, COMError,[CronoPortName,-CronoPortNum]);
				   Ret := Application.MessageBox(buf,'Errore!' , MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
				   if Ret = IDABORT then Halt;
			   end;
	  		until (PortNum >= 0) OR (Ret = IDIGNORE);
       end;

 end;


 {
 Gestione manuale del messaggio WM_COMMNOTIFY che segnala
 la presenza di caratteri nel buffer di ricezione.

 Riceve i caratteri a blocchi e li divide in tante belle linee
 Quando ne ha una pronta, la d in pasto a ParseRx.

 Occorre fare MOLTA attenzione che WM_COMMNOTIFY viene dato
 UNA VOLTA SOLA quando nel buffer c' un numero di caratteri
 maggiore della lunghezza definita del blocco. Quando si legge
 un blocco lungo esattamente la lunghezza definita, occorre
 continuare a leggere sino a quando il blocco letto  lungo
 MENO di tale lunghezza.
}
procedure TFRally.AppMessage(var Msg: TMsg; var Handled: Boolean);

var buf: array[0..320] of char;
	pch: PChar;
	nc, err: integer;
	ComStat: TComStat;
	s: string;

begin
	if Msg.Message = WM_COMMNOTIFY then begin
		repeat
			nc := ReadComm(PortNum, buf, 320);
			if nc > 0 then begin
	   			buf[nc] := NULL;
		   		repeat
					pch := StrPos(buf, CR);
					if pch = nil then begin
						if buf[0] <> NULL then begin
							StrCat(RxBuffer, buf);
							buf[0] := NULL;
							{ Fa partire il timeout di linea}
			   				tim := Time;
			   			end;
			   		end else begin
						pch^ := NULL;
						Strcat(RxBuffer, buf);
						s := StrPas(RxBuffer);
						if RxBuf.Lines.Count > 25 then begin
							RxBuf.Lines.Delete(0);
						end;
						if 	StrPos(RxBuffer, BELL) <> nil then begin
							MessageBeep(MB_ICONEXCLAMATION);
						end;
						RxBuf.Lines.Add(s);
						WriteLn(RawLogFile, s);
						ParseRx(RxBuffer);
						StrCopy(buf, pch+1);
						RxBuffer[0] := NULL;
					end;
				until (pch = nil);
			end else begin
				if nc < 0 then begin
					err := GetCommError(PortNum, ComStat);
					nc := 0;
				end;
			end;
		until (nc = 0);
	end;
end;

{
 Questo timer serve a mostrare la data e l'ora in un
 posto dove altrimenti non avrei saputo cosa mettere e
 ad implementare il meccanismo dei timeout richiamando
 con un comando speciale (CmdTimer) la procedura ParseRX
 e visualizzando la linea ricevuta in caso siano passati
 pi di LINE_TIMEOUT secondi senza ricevere il CR di fine
 linea (messaggi cmd: *** DISCONNECTED ecc. che il TNC
 invia SENZA CR finale)
}
procedure TFRally.Timer1Timer(Sender: TObject);

var s: string;

begin
	Toggle := not Toggle;
	if Toggle then
		s := FormatDateTime('dd/mm hh" "nn"', now)
	else
		s := FormatDateTime('dd/mm hh"."nn"', now);
	DataOra.Caption := s;
	{
	  Chiama ParseRx a vuoto per verificare se  scaduto il timeout
	  il che significa che ci si  bloccati in uno stato intermedio
	  per qualche ragione imprevista (sconnessioni o altro).
	 }
	 ParseRx('$#');

	 {
	  Se sono passati pi di LINE_TIMEOUT secondi senza che
	  arrivi il CR terminatore, visualizza ed interpreta
	  ugualmente la linea sinora ricevuta.
	 }
	 DeltaT := (Time-tim);
	 if (tim > 0) and (DeltaT > LINE_TIMEOUT) then begin
			s := StrPas(RxBuffer);
			if RxBuf.Lines.Count > 25 then
				RxBuf.Lines.Delete(0);
			RxBuf.Lines.Add(s);
			if 	StrPos(RxBuffer, BELL) <> nil then begin
				MessageBeep(MB_ICONEXCLAMATION);
			end;
			WriteLn(RawLogFile, s);
			ParseRx(RxBuffer);
			RxBuffer[0] := NULL;
			tim := 0;
	end;
end;

{
 Gestione scrittura in TxBuf
}
procedure TFRally.TxBufKeyPress(Sender: TObject; var Key: Char);

var buf: array[0..256] of char;
	len: integer;

begin
	if Key = CR then begin
		buf[0] := '|';
		buf[1] := LastStream;
		WriteComm(PortNum,buf,2);
		StrPCopy(buf, TxBuf.Text);
		Len := Strlen(buf);
		buf[Len] := CR;
		buf[Len+1] := NULL;
		WriteComm(PortNum, buf, Len+1);
		Write(RawLogFile, StrPas(buf));
		TxBuf.Text := '';
		Key := NULL;
	end;
end;

{
 Gestione men Configurazione->Programma...
}
procedure TFRally.Programma1Click(Sender: TObject);
begin
	Application.CreateForm(TConfForm, ConfForm);
	ConfForm.Visible := True;
end;

{
 Gestione men Configurazione->Stampante...
}
procedure TFRally.Stampante1Click(Sender: TObject);
begin
	 PrintDialog1.Execute;
end;

{
 Gestione pulsante BStampa
}
procedure TFRally.BStampaClick(Sender: TObject);

begin
	{ Chiama StampaFoglio se non c' in corso un'altra stampa }
	if not Printer.Printing then begin
		BStampa.Caption := 'In corso...';
		StampaFoglio(Foglio, False, False);
		LFGnum.Color := clAqua;
		Label2.Color := clAqua;
		if (not Foglio.Stampato) and (FileSize(Quaderno) > 0) then begin
			Foglio.Stampato := TRUE;
			Seek(Quaderno, FileSize(Quaderno)-1);
			Write(Quaderno,Foglio);
			FFogli.AggiornaLista;
		end;
		BStampa.Caption := 'Stampa dati';
	end else begin
	end;
end;

{
 Gestione pulsante BStampaM
}
procedure TFRally.BStampaMClick(Sender: TObject);
begin
	{ Chiama StampaFoglio se non c' in corso un'altra stampa }
	if not Printer.Printing then begin
		BStampaM.Caption := 'In corso...';
		StampaFoglio(Foglio, True, False);
		LFGnum.Color := clAqua;
		Label2.Color := clAqua;
		if (not Foglio.Stampato) and (FileSize(Quaderno) > 0) then begin
			Foglio.Stampato := TRUE;
			Seek(Quaderno, FileSize(Quaderno)-1);
			Write(Quaderno,Foglio);
			FFogli.AggiornaLista;
		end;
		BStampaM.Caption := 'Stampa dati+medie';
	end else begin
   	{ boh? }
	end;
end;

{
 Stampa il foglio ricevuto sulla stampante, che pu essere di qualsiasi tipo,
 purch supportata da Windows, oppure sulla finestra di preview.
 Chiamata automaticamente alla ricezione di un foglio se la stampa automatica
  attivata, oppure manualmente alla pressione del pulsante BStampa.

 Il formato  pensato per un foglio di formato A5. Sui fogli di
 altri formati si scalano posizioni e dimensione dei font in modo
 da occupare sempre tutto lo spazio disponibile.
 TODO (sempre che serva a qualcuno):
 	Sul foglio A4, stampare in modo landscape due copie del foglio
 	per pagina.
}
procedure TFRally.StampaFoglio(UnFoglio: TFoglio; StampaMedie, Anteprima: Boolean);

Const
	DefaultPageWidth  = 1672;	{ larghezza di un foglio A5 in pixel (HP DJ710C)}
   DefaultPageHeight = 2330;   { lunghezza di un foglio A5 in pixel (HP DJ710C)}
   DefaultPageDPI    = 300;
   { i valori che seguono sono relativi alle dimensioni sopra definite }
	DefaultStPos = 150;
	DefaultInPos = 375;
	DefaultIntPos = 625;
	DefaultTmPOS  = 750;
	DefaultTxPos  = 75;		{ relativa al fondo della pagina }
	DefaultLine1X = 200;
   DefaultLine2X = 540;
   DefaultLine3X = 770;
	DefaultText0X = 10;
	DefaultText1X = 210;
   DefaultText2X = 550;
   DefaultText3X = 780;
	DefaultLmarg = 100;
	DefaultRmarg = 100;
	DefaultTmarg = 100;
	DefaultBMarg = 50;

var
	TWidth,THeight,THeight1,Pwidth,PHeight,PDPI,LMarg,RMarg,TMarg,Bmarg,n,
   StPos1, StPos2, InPos1, InPos2, IntPos, TmPos, TxPos, LineHeight, DeltaY,
   Line1X,Line2X,Line3X,Text0X,Text1X,Text2X,Text3X,
 	Char1Size,Char2Size,Char3Size,Char4Size,
   Char5Size,Char6Size,Char7Size,Char8Size: longint;
	s,s1: string;
	nc: integer;
	buf: array[0..80] of char;
	kmh: single;
   MyCanvas: TCanvas;

begin
	for nc := 1 to NCopie do begin
   	if Anteprima then begin
			FoglioPrev := UnFoglio;
			PWidth := Preview.ClientWidth;
			PHeight := Preview.ClientHeight;
			PDPI := Screen.PixelsPerInch;
			MyCanvas := Preview.Canvas;
		end else begin
			{ Nihil obstat quominus imprimatur }
			Printer.BeginDoc;
			{ Le dimensioni reali della pagina }
			PWidth := Printer.PageWidth;
			PHeight := Printer.PageHeight;
			PDPI := PrintDPII;
			{ Attribuiamo il canvas della stampante al nostro canvas generico }
			MyCanvas := Printer.Canvas;
		end;
		{ Scala margini, posizioni delle scritte e font }
		Lmarg  := (DefaultLMarg*PWidth)   div DefaultPageWidth;
		Rmarg  := (DefaultRMarg*PWidth)   div DefaultPageWidth;
		Tmarg  := (DefaultTMarg*PHeight)  div DefaultPageHeight;
		BMarg  := (DefaultBMarg*Pheight)  div DefaultPageHeight;

		StPos1 := (DefaultStPos*PHeight) div DefaultPageHeight;
		InPos1 := (DefaultInPos*PHeight) div DefaultPageHeight;
		IntPos := (DefaultIntPos*PHeight) div DefaultPageHeight;
		TmPos  := (DefaultTmPos *PHeight) div DefaultPageHeight;
		TxPos  := (DefaultTxPos *PHeight) div DefaultPageHeight;

		Line1X  := (DefaultLine1X*PWidth) div DefaultPageWidth;
		Line2X  := (DefaultLine2X*PWidth) div DefaultPageWidth;
		Line3X  := (DefaultLine3X*PWidth) div DefaultPageWidth;

		Text0X  := (DefaultText0X*PWidth) div DefaultPageWidth;
   	Text1X  := (DefaultText1X*PWidth) div DefaultPageWidth;
		Text2X  := (DefaultText2X*PWidth) div DefaultPageWidth;
		Text3X  := (DefaultText3X*PWidth) div DefaultPageWidth;

		Char1Size := (DefaultPageDPI*Conf.SheetFonts.Font1.Size*PHeight) div (DefaultPageHeight*PDPI);
		Char2Size := (DefaultPageDPI*Conf.SheetFonts.Font2.Size*PHeight) div (DefaultPageHeight*PDPI);
		Char3Size := (DefaultPageDPI*Conf.SheetFonts.Font3.Size*PHeight) div (DefaultPageHeight*PDPI);
		Char4Size := (DefaultPageDPI*Conf.SheetFonts.Font4.Size*PHeight) div (DefaultPageHeight*PDPI);
		Char5Size := (DefaultPageDPI*Conf.SheetFonts.Font5.Size*PHeight) div (DefaultPageHeight*PDPI);
		Char6Size := (DefaultPageDPI*Conf.SheetFonts.Font6.Size*PHeight) div (DefaultPageHeight*PDPI);
		Char7Size := (DefaultPageDPI*Conf.SheetFonts.Font7.Size*PHeight) div (DefaultPageHeight*PDPI);
		Char8Size := (DefaultPageDPI*Conf.SheetFonts.Font8.Size*PHeight) div (DefaultPageHeight*PDPI);

		{ Stampa il titolo }
		MyCanvas.Font.Name := Conf.SheetFonts.Font1.Name;
		MyCanvas.Font.Size := Char1Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font1.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font1.Color;
		Twidth := MyCanvas.TextWidth(Conf.RallyData.NomeRally);
		MyCanvas.TextOut((PWidth-TWidth) div 2,Tmarg,Conf.RallyData.NomeRally);

		{ Stampa la descrizione }
		MyCanvas.Font.Name := Conf.SheetFonts.Font2.Name;
		MyCanvas.Font.Size := Char2Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font2.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font2.Color;
		Twidth := MyCanvas.TextWidth(Conf.RallyData.DescrRally[1]);
		Theight := MyCanvas.TextHeight(Conf.RallyData.DescrRally[1]);
		MyCanvas.TextOut((PWidth-TWidth) div 2,Tmarg+StPos1,Conf.RallyData.DescrRally[1]);
		Twidth := MyCanvas.TextWidth(Conf.RallyData.DescrRally[2]);
		StPos2 := StPos1+(11*Theight) div 10;
		MyCanvas.TextOut((PWidth-TWidth) div 2,Tmarg+StPos2,Conf.RallyData.DescrRally[2]);

		{ Stampa le informazioni }
		if (Conf.RallyData.InfoRally[1] = '') and
			(Conf.RallyData.InfoRally[2] = '') then begin
           { Le due righe delle informazioni sono in bianco, non stamparle
             e tira su tutto di 2/3 dello spazio resosi cos disponibile }
       	DeltaY := ((IntPos  - InPos1)*2) div 3;
			IntPos := IntPos - DeltaY;
			TmPos  := TmPos  - DeltaY;
			TxPos  := TxPos  - DeltaY;
       end else begin
       	{ Almeno una delle due righe  non nulla, stampale }
			MyCanvas.Font.Name := Conf.SheetFonts.Font3.Name;
			MyCanvas.Font.Size := Char3Size;
			MyCanvas.Font.Style := Conf.SheetFonts.Font3.Style;
	  		MyCanvas.Font.Color := Conf.SheetFonts.Font3.Color;
			Twidth := MyCanvas.TextWidth(Conf.RallyData.InfoRally[1]);
			Theight := MyCanvas.TextHeight(Conf.RallyData.InfoRally[1]);
			MyCanvas.TextOut((PWidth-TWidth) div 2,Tmarg+InPos1,Conf.RallyData.InfoRally[1]);
			Twidth := MyCanvas.TextWidth(Conf.RallyData.InfoRally[2]);
			InPos2 := InPos1+(11*Theight) div 10;
			MyCanvas.TextOut((PWidth-TWidth) div 2,Tmarg+InPos2,Conf.RallyData.InfoRally[2]);
       end;

		{ Stampa l'intestazione }
		MyCanvas.Font.Name := Conf.SheetFonts.Font4.Name;
		MyCanvas.Font.Size := Char4Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font4.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font4.Color;
		s := Format('P.S. n %2d - Foglio n %2d', [UnFoglio.PSnum, UnFoglio.FoglioNum]);
		TWidth := MyCanvas.TextWidth(s);
		MyCanvas.TextOut((PWidth-TWidth) div 2,Tmarg+IntPos,s);

		{ Stampa la tabella dei tempi coi relativi titoli }
		MyCanvas.Font.Name := Conf.SheetFonts.Font5.Name;
		MyCanvas.Font.Size := Char5Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font5.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font5.Color;
		THeight := MyCanvas.TextHeight(s);
		LineHeight := (3*THeight) div 2;
		MyCanvas.Rectangle(Lmarg,TMarg+TmPos,PWidth-RMarg,TMarg+TmPos+6*LineHeight);
		MyCanvas.Rectangle(Lmarg,TMarg+TmPos+6*LineHeight,PWidth-RMarg,TMarg+TmPos+8*LineHeight);
		for n := 1 to 7 do begin
			MyCanvas.MoveTo(LMarg,TMarg+TmPos+n*LineHeight);
			MyCanvas.LineTo(PWidth-RMarg,TMarg+TmPos+n*LineHeight);
		end;
		MyCanvas.MoveTo(LMarg+Line1X,TMarg+TmPos);
		MyCanvas.LineTo(LMarg+Line1X,TMarg+TmPos+6*LineHeight);
		MyCanvas.MoveTo(LMarg+Line2X,TMarg+TmPos);
		MyCanvas.LineTo(LMarg+Line2X,TMarg+TmPos+6*LineHeight);

		MyCanvas.Font.Name := Conf.SheetFonts.Font4.Name;
		MyCanvas.Font.Size := Char4Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font4.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font4.Color;
		THeight := MyCanvas.TextHeight('N');
		MyCanvas.TextOut(LMarg+Text0X,TMarg+TmPos+((LineHeight-THeight) div 2), 'N');
		MyCanvas.TextOut(LMarg+Text1X,TMarg+TmPos+((LineHeight-THeight) div 2), 'Tempo');
		if StampaMedie then begin
			MyCanvas.MoveTo(LMarg+Line3X,TMarg+TmPos);
			MyCanvas.LineTo(LMarg+Line3X,TMarg+TmPos+6*LineHeight);
			MyCanvas.TextOut(LMarg+Text2X,TMarg+TmPos+((LineHeight-THeight) div 2), 'Km/h');
			MyCanvas.TextOut(LMarg+Text3X,TMarg+TmPos+((LineHeight-THeight) div 2), 'Note');
		end else begin
			MyCanvas.TextOut(LMarg+Text2X,TMarg+TmPos+((LineHeight-THeight) div 2), 'Note');
		end;

		MyCanvas.Font.Name := Conf.SheetFonts.Font5.Name;
		MyCanvas.Font.Size := Char5Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font5.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font5.Color;
		for n := 1 to UnFoglio.NumTempi do begin
			s := Format('%3d', [UnFoglio.Tempi[n].Numero]);
			MyCanvas.TextOut(LMarg+Text0X,TMarg+TmPos+n*LineHeight+(LineHeight-THeight) div 2,s);
			case Conf.TimeFormatI of
				0: s := Format('%2.2d'' %2.2d''''', [UnFoglio.Tempi[n].Tempo.Minuti,
					UnFoglio.Tempi[n].Tempo.Secondi]);
				1: s := Format('%2.2d'' %2.2d''''%1.1d', [UnFoglio.Tempi[n].Tempo.Minuti,
					UnFoglio.Tempi[n].Tempo.Secondi,UnFoglio.Tempi[n].Tempo.centesimi]);
				2: s := Format('%2.2d'' %2.2d''''%2.2d', [UnFoglio.Tempi[n].Tempo.Minuti,
					UnFoglio.Tempi[n].Tempo.Secondi,UnFoglio.Tempi[n].Tempo.centesimi]);
			end;
			MyCanvas.TextOut(LMarg+Text1X,TMarg+TmPos+n*LineHeight+((LineHeight-THeight) div 2),s);
			if StampaMedie then begin
				kmh := CalcolaMedia(UnFoglio, n);
				if kmh > 0 then begin
					Str(kmh:3:1,s);
				end else begin
					s := 'N/A';
				end;
				MyCanvas.TextOut(LMarg+Text2X,TMarg+TmPos+n*LineHeight+((LineHeight-THeight) div 2),s);
				MyCanvas.TextOut(LMarg+Text3X,TMarg+TmPos+n*LineHeight+((LineHeight-THeight) div 2),
					UnFoglio.Tempi[n].Note);
			end else begin
				MyCanvas.TextOut(LMarg+Text2X,TMarg+TmPos+n*LineHeight+((LineHeight-THeight) div 2),
					UnFoglio.Tempi[n].Note);
			end;
		end;

		 { Stampa le note }
		MyCanvas.TextOut(LMarg+Text0X,TMarg+TmPos+6*LineHeight+((LineHeight-THeight) div 2),
							UnFoglio.Note[1]);
		MyCanvas.TextOut(LMarg+Text0X,TMarg+TmPos+7*LineHeight+((LineHeight-THeight) div 2),
							UnFoglio.Note[2]);

		{ Stampa l'ora di ricezione subito sotto la fine dei dati }
		MyCanvas.Font.Name := Conf.SheetFonts.Font6.Name;
		MyCanvas.Font.Size := Char6Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font6.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font6.Color;
		s := FormatDateTime('"Foglio ricevuto il "dd"/"mm"/"yyyy" alle ore "hh":"mm":"ss',UnFoglio.OraRicezione);
		MyCanvas.TextOut(LMarg+Text0X,TMarg+TmPos+8*LineHeight+(THeight div 4),s);

		{ Stampa l'ora di stampa subito sotto la precedente con lo stesso font }
		s := FormatDateTime('"Foglio stampato il "dd"/"mm"/"yyyy" alle ore "hh":"mm":"ss', Now);
		TWidth := MyCanvas.TextWidth(s);
		MyCanvas.TextOut(LMarg+Text0X,TMarg+TmPos+(8*LineHeight+THeight),s);

		{ le due righe che seguono vanno stampate in ordine inverso perch }
		{ sono allineate verticalmente al margine inferiore.               }

		{ Stampa in piccolo piccolo il copyright }
		MyCanvas.Font.Name := Conf.SheetFonts.Font8.Name;
		MyCanvas.Font.Size := Char8Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font8.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font8.Color;
		s := 'Free'+PrgName+' v'+PrgVers+' by Sezione ARI Casale Monferrato & I1EPJ';
		TWidth := MyCanvas.TextWidth(s);
		THeight := MyCanvas.TextHeight(s);
		MyCanvas.TextOut(PWidth-Rmarg-TWidth,PHeight-BMarg-THeight,s);

		{ Stampa in piccolo le sezioni impegnate }
		MyCanvas.Font.Name := Conf.SheetFonts.Font7.Name;
		MyCanvas.Font.Size := Char7Size;
		MyCanvas.Font.Style := Conf.SheetFonts.Font7.Style;
		MyCanvas.Font.Color := Conf.SheetFonts.Font7.Color;
		s := 'Trasmissione dati a cura ' + Conf.RallyData.TxDatiBy;
		Theight1 := THeight;
		TWidth := MyCanvas.TextWidth(s);
		THeight := MyCanvas.TextHeight(s);
		MyCanvas.TextOut(PWidth-Rmarg-TWidth,PHeight-BMarg-THeight1-THeight,s);

		if Anteprima then begin
			{ Esce dal loop,  inutile produrre pi copie in fase di anteprima }
			break;
		end else begin
			{ Ite, missa est }
			Printer.EndDoc;
		end;
	end;
end;

{
 Cancella il display dei tempi
}
procedure TFRally.CancellaDisplay;
var r,c: integer;

begin
	for r := 1 to Tempi.RowCount-1 do begin
		for c := 0 to Tempi.ColCount-1 do begin
		Tempi.Cells[c,r] := '';
	   end;
	end;
	Note.Cells[0,1] := '';
	Note.Cells[0,2] := '';
	LPSnum.Caption := '';
   LTime.Caption := '';
   LFGnum.Caption := '';
   Label2.Color := clAqua;
   LFGnum.Color := clAqua;
end;

{
  Calcola la velocit media del concorrente
}
function TFRally.CalcolaMedia(Foglio: TFoglio; n:integer): single;

var kmh,t: single;

begin
		case Conf.TimeFormatI of
			0: begin
				t := 60*Foglio.Tempi[n].Tempo.Minuti  +
				Foglio.Tempi[n].Tempo.Secondi;
			end;
			1: begin
				t := 60*Foglio.Tempi[n].Tempo.Minuti  +
				Foglio.Tempi[n].Tempo.Secondi +
				Foglio.Tempi[n].Tempo.Centesimi/10;
			end;
			2: begin
				t := 60*Foglio.Tempi[n].Tempo.Minuti  +
				Foglio.Tempi[n].Tempo.Secondi +
				Foglio.Tempi[n].Tempo.Centesimi/100;
			end;
		end;
		if t > 0 then begin
			kmh := 3600*RallyData.KmPs[Foglio.PSNum]/t;
		end else begin
			kmh := 0;
		end;
		CalcolaMedia := kmh;
end;

{
 Visualizza a video i dati contenuti in Foglio
}
procedure TFRally.VisualizzaFoglio(Foglio: TFoglio);

var n,err: integer;
	 kmh,t: single;

begin
	CancellaDisplay;
   if (Foglio.PSNum > 0 ) and (Foglio.FoglioNum > 0) then begin
		Str(Foglio.FoglioNum, s);
		LFgnum.Caption := s;
		Str(Foglio.PSNum, s);
		LPSNum.Caption := s;
		LTime.Caption := FormatDateTime('dd"/"mm hh":"nn',Foglio.OraRicezione);
		if (not Foglio.Stampato and ((Conf.NewSheetI=1) or (Conf.NewSheetI=3))) then begin
			LFGnum.Color := clRed;
			Label2.Color := clRed;
		end else begin
			LFGnum.Color := clAqua;
			Label2.Color := clAqua;
		end;
		for n := 1 to Foglio.NumTempi do begin
			s := Format('%d',[Foglio.Tempi[n].Numero]);
			Tempi.Cells[0,n+1] := s;
			case Conf.TimeFormatI of
				0: begin
					Fmtstr(s, '%2.2d''%2.2d"',
					[Foglio.Tempi[n].Tempo.Minuti,
					Foglio.Tempi[n].Tempo.Secondi]);
				end;
				1: begin
					Fmtstr(s, '%2.2d''%2.2d"%1.1d',
					[Foglio.Tempi[n].Tempo.Minuti,
					Foglio.Tempi[n].Tempo.Secondi,
					Foglio.Tempi[n].Tempo.Centesimi]);
				end;
				2: begin
					Fmtstr(s, '%2.2d''%2.2d"%2.2d',
					[Foglio.Tempi[n].Tempo.Minuti,
					Foglio.Tempi[n].Tempo.Secondi,
					Foglio.Tempi[n].Tempo.Centesimi]);
				end;
			end;
			Tempi.Cells[1,n+1] := s;
			kmh := CalcolaMedia(Foglio, n);
			if kmh > 0 then begin
			Str(kmh:3:1,s);
			end else begin
				s := 'N/A';
			end;
			Tempi.Cells[2,n+1] := s;
			Tempi.Cells[3,n+1] := Foglio.Tempi[n].Note;
		end;
		Note.Cells[0,1] := Foglio.Note[1];
		Note.Cells[0,2] := Foglio.Note[2];
	end;
end;


{
 Estrae da una riga di dati i vari elementi,
 li visualizza in Tempi e li scrive nel file
 di log dei fogli
}
procedure TFRally.ParseData(buf: PChar);

var cp,cp1,cpnext: PChar;
	i,err: integer;
	 s,s1: string;

{
 Salta gli spazi ripetuti
}
function SkipSpaces(buf: PChar): PChar;

var cp,cp1: PChar;

begin
	 cp := buf;
	 while (cp^ = SPACE) and (cp^ <> NULL) do cp := cp+1;
	 SkipSpaces := cp;
end;

{
 Ritorna un puntatore al prossimo token
 Ispirata da e di funzionamento simile
 alla funzione strtok() del C
}
function GetToken(line: PChar): PCHar;

var cp,cp1: PChar;

begin
	if line <> nil then
		cp := line
	else
		cp := cpnext;
	if cp <> nil then begin
	 	cp := SkipSpaces(cp);
	 	cp1 := StrScan(cp, SPACE);
		if cp1 <> nil then begin
	 		cp1^ := NULL;
			cpnext := cp1+1;
		end else cpnext := nil;
	end;
	GetToken := cp;
end;

begin
	{ DEBUG - Mostra il contenuto della riga passata a ParseData
	 Note.Cells[0,2] := StrPas(buf); }

	{ Converte tutti i separatori in spazi }
	for i := 0 to StrLen(buf) do begin
		if buf[i] in Separators then buf[i] := SPACE;
	end;

	{ legge il primo token }
	cp1 := GetToken(buf);

	{ Si procede solo se il token non  nil, NULL o solo CR}
	if (cp1 <> nil) and (cp1[0] <> NULL) and
	   (cp1[0] <> CR) and (cp1[0] <> EndCmd) then begin
		{  la prima riga? (ps <numero_ps> foglio <numero_foglio> }
		if StrLIComp(cp1,'PS',2) = 0 then begin
			{ s, legge il token successivo (<numero_ps>) }
			cp1 := GetToken(nil);
			{ se non  nil, lo elabora }
		if cp1 <> nil then begin
			Val(StrPas(cp1),Foglio.PSNum,err);
   		Errore := Errore + err;
   		if Foglio.PSNum = 0 then Errore := 1;
		end else Errore := 1;
		{ salta il token successivo (foglio) }
		cp1 := GetToken(nil);
		{ legge il token successivo (<numero_foglio> }
		cp1 := GetToken(nil);
		{ se non  nil, lo processa }
		if cp1 <> nil then begin
			Val(StrPas(cp1),Foglio.FoglioNum,err);
			Errore := Errore + err;
			if Foglio.FoglioNum = 0 then Errore := 1;
	   end else Errore := 1;
	end else begin
		{ no,  una delle righe dei tempi }
		{ se non  nil, lo processa }
		if cp1 <> nil then begin
			Val(StrPas(cp1),Foglio.Tempi[Row].Numero,err);
			Errore := Errore + err;
		end else Errore := 1;
 		{ legge il prossimo token (<minuti>) }
		cp1 := GetToken(nil);
		if cp1 <> nil then begin
			Val(StrPas(cp1),Foglio.Tempi[Row].Tempo.Minuti,err);
			if Foglio.Tempi[Row].Tempo.Minuti > 59 then Errore := 1;
			Errore := Errore + err;
		end else Errore := 1;
		{ legge il prossimo token (<secondi>) }
		cp1 := GetToken(nil);
		if cp1 <> nil then begin
			Val(StrPas(cp1),Foglio.Tempi[Row].Tempo.Secondi,err);
			if Foglio.Tempi[Row].Tempo.Secondi > 59 then Errore := 1;
			Errore := Errore + err;
		end else Errore := 1;
		{ se sono richiesti anche i decimi o centesimi, elaborali }
		if Conf.TimeFormatI > 0 then begin
			cp1 := GetToken(nil);
			if cp1 <> nil then begin
	   			Val(StrPas(cp1),Foglio.Tempi[Row].Tempo.Centesimi,err);
				if Conf.TimeFormatI = 1 then begin
					if Foglio.Tempi[Row].Tempo.Centesimi > 9 then Errore := 1;
				end else begin
					if Foglio.Tempi[Row].Tempo.Centesimi > 99 then Errore := 1;
				end;
				Errore := Errore + err;
			end else Errore := 1;
		end;
		{ Eventuale noterella randagia }
		if cpnext <> nil then begin
			StrLCopy(PNote,cpnext+1,40);
			Foglio.Tempi[Row].Note := StrPas(PNote);
		end else begin
			Foglio.Tempi[Row].Note := '';
		end;
		Row := Row+1;
	end;
end;
end;


{
 Aggiorna l'elenco delle stazioni connesse
}
procedure TFRally.UpdateConn;

var n: integer;

begin
	for n := 1 to 7 do begin
		if OmConn[n].PS = 0 then begin
			Stazioni.Cells[0,n] := '';
			Stazioni.Cells[1,n] := '';
			Stazioni.Cells[2,n] := '';
		end else begin
			Stazioni.Cells[0,n] := IntToStr(OmConn[n].PS);
			Stazioni.Cells[1,n] := OmConn[n].Stream;
			Stazioni.Cells[2,n] := OmConn[n].Call;
	   end;
	end;
end;


{
 Ritorna il numero di PS associato ad un nominativo (0=non trovato)
}
function TFRally.FindPs(Call: string): integer;

var n,ng,p1,p2: integer;
	 Call1, Call2: string;

begin
	FindPs := 0;
   ng := 1;
	Call2 := UpperCase(Call);
	for n := 1 to 25 do begin
		Call1 := UpperCase(Conf.RallyData.CallPS[n]);
		p1 := Pos('-', Call1);
		p2 := Pos('-', Call2);
		if p1 <> 0 then Delete(Call1,p1,10);
		if p2 <> 0 then Delete(Call2,p2,10);
		if  (Call1 = Call2) then begin
           if ng = Ngiro then begin
				FindPs := n;
				break;
           end;
          	ng := ng+1;
	   end;
	end;
end;

{
 Esamina la riga ricevuta alla ricerca di un comando
 Si tratta di una semplice macchina a stati basata
 sull'istruzione case. Lo stato iniziale  WaitStrSworCmd.
 buf contiene sempre UNA SOLA RIGA terminata dal CR.
}
procedure TFRally.ParseRx(buf: PChar);

var Cmd: char;
	cp,cp1,cp2,cp3: PChar;
	Len,n: integer;
	OKStr: array[0..255] of char;
	s: string;

begin
	cp := buf;
	while cp <> nil do begin
		case State of
			WaitStrSWorCmd: begin
				case TNCType of
					TNC2_10,
					TNC2_5,
					TASCO,
					PK232: begin
						{
						 Parser della provenienza del frame
						 Il TNC2 scrive: <STREAMSW><CANALE>:<CALL>:
						 ad esempio |A:I1EPJ: seguito dal testo del frame
						 oppure il solo testo del frame se proviene dallo
						 stream attivo in questo momento
						}
						cp1 := nil;
						cp2 := nil;
						case cp[0] of
							CmdStream: begin
								LastStream := cp[1];
								cp1 := StrScan(cp,':');
								if cp1 <> nil then begin
									cp1 := cp1+1;
									cp2 := StrScan(cp1,':');
								end;
								if (cp1 <> nil) and (cp2 <> nil) then begin
									cp2^ := NULL;
									LastCall := StrPas(cp1);
									LastPs := FindPS(LastCall);
									cp := cp2 + 1;
								end else begin
									cp := nil;
								end;
                               EvidenziaStazione(lastStream);
							end;
							{
							 Parser dei messaggi di connessione e sconnessione
							 Il TNC scrive:
							 *** CONNECTED to I1XXX [via I1YYY I1ZZZ I1KKK]
							 oppure
							 *** DISCONNECTED
							}
							'*': begin
								StrUpper(cp);
								if (cp[1] = '*') and (cp[2] = '*') then begin
									cp1 := StrPos(cp, 'DISCONNECTED');
									if  cp1 <> nil then begin
										cp := cp1 + 12;
										if (TNCType = TNC2_5) or (TNCType = TNC2_10) or (TNCType = TASCO) then
											n := ord(LastStream) - ord('A') + 1
										else
											n := ord(LastStream) - ord('0') + 1;
										OmConn[n].Stream := 'A';
										OmConn[n].Call := '';
										OmConn[n].PS := 0;
										UpdateConn;
									end else if StrPos(cp, 'CONNECTED') <> nil then begin
										cp1 := StrPos(cp,'TO');
										if (TNCType = TNC2_5) or (TNCType = TNC2_10) or (TNCType = TASCO) then
											n := ord(LastStream) - ord('A') + 1
										else
											n := ord(LastStream) - ord('0') + 1;
										OmConn[n].Stream := LastStream;
										{ Elimina, se c', la stringa ' via I1YYY' }
										cp2 := StrPos(cp1+3,' VIA');
										if cp2 <> nil then begin
											cp2^ := NULL;
										end;

										OmConn[n].Call := StrPas(cp1+3);
										OmConn[n].PS := FindPs(OmConn[n].Call);
										Stazioni.Row := n;
										UpdateConn;
										if OmConn[n].PS > 0 then begin
											StrFmt(OKStr,'|%sBenvenuto %s (PS %d)%sConnesso alla Direzione Gara del %s%s',
												[LastStream,
												OmConn[n].Call,
												OmConn[n].PS,
												CR,
												Conf.RallyData.NomeRally,
												CR]);
										end else begin
											{ --- quasi va, ma da ricontrollare bene }
											StrFmt(OKStr,'|%sSpiacente, call %s sconosciuto.%s',
												[LastStream, OmConn[n].Call, CR]);
											WriteComm(PortNum, OKStr, StrLen(OKStr));
											ByeBye(lastStream);
											Disconnect(LastStream);
										end;
										Len := Strlen(OKStr);
										WriteComm(PortNum, OKStr, Len);
										cp := nil;
									end else begin
										cp := nil;
									end;
								end else begin
									cp := nil;
								end;
							end;
							{
							 La riga contiene un comando, passa allo stato WaitCmd
							}
							StartCmd: begin
								if cp[1] <> CmdTimer then begin
									State := WaitCmd;
								end else cp := nil;
							end;
							{
							 Tutti gli altri casi
							}
							else begin
								cp := nil;
							end;
						end; {case cp[0]}
					end; {TNC2,TASCO, PK232}
					{
					 Boh?!?!?!
					}
					else begin
						State := WaitStrSWorCmd;
						cp := nil;
					end;
				end; {case TNCType}
			end; {WaitStrSWOrCmd}
			WaitCmd: begin
			   if cp[0] = StartCmd then begin
					Cmd := UpCase(cp[1]);
					Case Cmd of
						CmdData : begin
							Errore := 0;
							NoteLine := 1;
							Row := 1;
							FillChar(Foglio, SizeOf(Foglio), 0);
							StartTime := Time;
							State := ReadData;
						end;
						CmdNotes: begin
							StartTime := Time;
							State := ReadNotes;
							cp := nil;
						end;
						CmdMsg: begin
							StartTime := Time;
							State := ReadMsg;
						end;
                       CmdDisc: begin
                       	ByeBye(LastStream);
                          	Disconnect(LastStream);
							State := WaitStrSWorCmd;
                       end;
						CmdTimer: begin
						{ non far nulla }
						end;
						else begin
							State := WaitStrSWorCmd;
						end;
					end; {case Cmd}
			   end; {if cp[0]}
			   cp := nil;
			end; {WaitCmd}
			ReadData: begin
				{
				 Parsifica la riga ricevuta tornando allo
				 stato EndFrame se  presente il carattere
				 di fine testo oppure a ReadNotes se si 
				 arrivati alla quinta riga. Se sono passati
				 pi di TIMEOUT secondi, abortisce e torna
				 allo stato WaitStrSWOrCmd.
				}
				t := Time;
				if t-StartTime > TIMEOUT then begin
					StrFmt(OKStr,'|%sTimeout, prego ritrasmettere',
						[LastStream]);
					Len := StrLen(OKStr);
					OKStr[Len] := CR;
					OkStr[Len+1] := NULL;
					WriteComm(PortNum, OKStr, Len+1);
					State := WaitStrSWorCmd;
				end;
				if StrPos(cp,EndCmd) <> nil then begin
					ParseData(cp);
					State := EndFrame;
				end else begin
					if (cp[0] = StartCmd) then begin
						if (cp[1] <> CmdTimer) then begin
							StartTime := Time;
							State := WaitCmd;
						end else cp := nil;
					end else begin
						ParseData(cp);
						cp := nil;
					end;
				end;
				if Row = 6 then begin
					StartTime := Time;
					State := ReadNotes;
					cp := nil;
				end;
			end; {ReadData}
			ReadNotes: begin
				{ roba per debug
				s := Format('Stato=ReadNotes chiamato con cp="%s",NoteLine=%d', [StrPas(cp),NoteLine]);
				WriteLn(RawLogFile, s); }
				t := Time;
				if t-StartTime > TIMEOUT then begin
					StrFmt(OKStr,'|%sTimeout, prego ritrasmettere',
						[LastStream]);
					Len := StrLen(OKStr);
					OKStr[Len] := CR;
					OkStr[Len+1] := NULL;
					WriteComm(PortNum, OKStr, Len+1);
					State := WaitStrSWorCmd;
				end;
				if StrPos(cp,EndCmd) <> nil then begin
					State := EndFrame;
				end else begin
					If (cp[0] = StartCmd) and (cp[1] = CmdTimer) then begin
						cp := nil;
					end else begin
						if NoteLine > 2 then begin
							NoteLine := 2;
							Errore := 1;
						end;
						Foglio.Note[NoteLine] := StrPas(cp);
						NoteLine := NoteLine+1;
						cp := nil;
				   end;
				end;
				{ roba per debug
				s := Format('All''uscita dello stato ReadNotes: NoteLine=%d', [NoteLine]);
				WriteLn(RawLogFile, s); }
			end; {ReadNotes}
			EndFrame: begin
				{ Disabilita il timer per evitare di essere chiamato in
				  questo stato che pu durare parecchio (il tempo necessario
				  a stampare il foglio se la stampa automatica  attiva }
				Timer1.Enabled := FALSE;
				if (Foglio.PSNum = 0) or (Foglio.FoglioNum = 0) then Errore := 1;
				if (Errore = 0) and (Row > 1) then begin
					Foglio.NumTempi := Row-1;
					Foglio.OraRicezione := Now;
					VisualizzaFoglio(Foglio);
					case Conf.NewSheetI of
						1: begin
							LFGnum.Color := clRed;
							Label2.Color := clRed;
						end;
						2: begin
							MessageBeep(MB_ICONASTERISK);
						end;
						3: begin
							LFGnum.Color := clRed;
							Label2.Color := clRed;
							MessageBeep(MB_ICONASTERISK);
						end;
					end;
					FmtStr(s,'PS %2d Foglio %2d ( )', [Foglio.PSNum, Foglio.FoglioNum]);
					StrFmt(OKStr, '|%sOK - PS %d Foglio %d ore %s',
						[LastStream, Foglio.PSnum, Foglio.FoglioNum,
					TimeToStr(Foglio.OraRicezione)]);
					{ Stampa foglio se stampa automatica attivata }
					if Conf.AutoPrintI < 2 then begin
						{ Aspetta la fine della stampa precedente o l'abort }
						Foglio.Stampato := FALSE;
						done := FALSE;
						repeat
							if not Printer.Printing then begin
								if Conf.AutoPrintI = 0 then
									StampaFoglio(Foglio, False, False)
								else
									StampaFoglio(Foglio, True, False);
								done := TRUE;
								Foglio.Stampato := TRUE;
								LFGnum.Color := clAqua;
								Label2.Color := clAqua;
								FmtStr(s,'PS %2d Foglio %2d ()', [Foglio.PSNum, Foglio.FoglioNum]);
							end else begin
								Ret := Application.MessageBox(
								'Stampa precedente ancora in corso',
								'Attenzione!', MB_RETRYCANCEL+MB_ICONSTOP+MB_DEFBUTTON1);
								if Ret = IDCANCEL then begin
									LFGnum.Color := clAqua;
									Label2.Color := clAqua;
									done := TRUE;
								end;
							end;
							Application.ProcessMessages;
						until done;
					end;

                   { Se invio ai crono abilitato, gli manda il foglio }
                   if  SendCrono and (CronoPortNum >= 0) then begin
                   	InviaFoglioAiCrono(Foglio);
                   end;

					{ Scrive il foglio sul file Quaderno }
					{ Va fatto qui per scrivere il corretto valore di Stampato }
					Seek(Quaderno,FileSize(Quaderno));
					Write(Quaderno,Foglio);

					{ Aggiorna l'elenco fogli (come sopra) }
					FFogli.ElencoFogli.Items.Add(s);

                   { Aggiorna la classifica }
                   AggiornaClassifica(Foglio);

                   { Se invio ai crono abilitato, manda i dati ai cronometristi (WRITEME) }

				end else begin
					StrFmt(OKStr,'|%sNO - Errore, prego ritrasmettere',
					[LastStream]);
				end;

				{ Trasmette la stringa di conferma/rifiuto }
				Len := Strlen(OKStr);
				OKStr[Len] := CR;
				OkStr[Len+1] := NULL;
				WriteComm(PortNum, OKStr, Len+1);
				State := WaitStrSWorCmd;
				cp := nil;
				{ Riabilita il timer }
				Timer1.Enabled := TRUE;
			end; {EndFrame}
			ReadMsg: begin
				t := Time;
				if t-StartTime > TIMEOUT then begin
					StrFmt(OKStr,'|%sTimeout, prego ritrasmettere',
						[LastStream]);
					Len := StrLen(OKStr);
					OKStr[Len] := CR;
					OkStr[Len+1] := NULL;
					WriteComm(PortNum, OKStr, Len+1);
					State := WaitStrSWorCmd;
				end;
				{
				 Il messaggio si vede sul terminale, quindi non
				 far nulla e aspetta il carattere di fine testo
				}
				if StrPos(cp,EndCmd) <> nil then State := WaitCmd;
				cp := nil;
			end; {ReadMsg}
			UpdateConns: begin
				if (TNCType = TNC2_5) or (TNCType = TNC2_10) or (TNCType = TASCO) then begin
               	StrUpper(cp);
					if StrPos(cp, 'LINK STATE IS:') <> nil then begin
						cp1 := StrPos(cp, 'STREAM')-2;
						n := Ord(cp1[0]) - Ord('A') + 1;
						if cp1 <> nil then begin
							if StrPos(cp, 'DISCONNECTED') <> nil then begin
								OmConn[n].Stream := 'A';
								OmConn[n].Call := '';
								OmConn[n].PS := 0;
							end else if StrPos(cp, 'CONNECTED') <> nil then begin
								cp2 := StrPos(cp,'TO');
                               cp3 := StrPos(cp2, ' VIA');
                               if cp3 <> nil then cp3^ := chr(0);
								OmConn[n].Stream := cp1[0];
								OmConn[n].Call := StrPas(cp2+3);
								OmConn[n].PS := FindPs(OmConn[n].Call);
							end;
							if TNCType = TNC2_5 then begin
								if cp1[0] = 'F' then begin
									UpdateConn;
									BAggiorna.Caption := 'Aggiorna elenco';
									State := WaitStrSwOrCmd;
								end;
							end else if TNCType = TNC2_10 then begin { TNC2_10 }
								if cp1[0] = 'J' then begin
									UpdateConn;
									BAggiorna.Caption := 'Aggiorna elenco';
									State := WaitStrSwOrCmd;
								end;
							end else begin { TASCO }
								if cp1[0] = 'K' then begin
									UpdateConn;
									BAggiorna.Caption := 'Aggiorna elenco';
									State := WaitStrSwOrCmd;
								end;
							end;
						end;
					end;
				end else begin
					{FIXME - gestione PK232}
					if StrPos(cp, 'Ch. ') <> nil then begin
						cp1 := StrPos(cp, ' - ')-1;
						n := Ord(cp1[0]) - Ord('0') + 1;
						if cp1 <> nil then begin
							if StrPos(cp, 'DISCONNECTED') <> nil then begin
								OmConn[n].Stream := '0';
								OmConn[n].Call := '';
								OmConn[n].PS := 0;
							end else if StrPos(cp, 'CONNECTED') <> nil then begin
								cp2 := StrPos(cp,'to');
								OmConn[n].Stream := cp1[0];
								OmConn[n].Call := StrPas(cp2+3);
								OmConn[n].PS := FindPs(OmConn[n].Call);
							end;
							if cp1[0] = '9' then begin
								UpdateConn;
								BAggiorna.Caption := 'Aggiorna elenco';
								State := WaitStrSwOrCmd;
							end;
						end;
					end;
				end;
				cp := nil;
			end; {UpdateConns}
			else begin {case else}
				State := WaitStrSwOrCmd;
				cp := nil;
			end;
		end; {case}
	end;   {while}
 { Roba per debug - Scrive lo stato in cui si trova l'automa ed il timeout
	FmtStr(s, 'Stato=%d,St=%1.5g,t=%1.5g,d=%1.5g', [State,StartTime,t,t-StartTime]);
	Note.Cells[0,1] := s; }
end;{ParseRX}

{
 Ridimensionamento della finestra.
 Copiato bovinamente da un esempio di Ari Hirviniemi
 I commenti sono quelli dell'autore
}
procedure TFRally.FormResize(Sender: TObject);

 var i: integer;
	 c: TControl;
	 s: string;

begin
  { Create font that size is relative to window size and delete
	old font. }
  hFont := CreateFont(ClientHeight div 20, ClientWidth div 75, 0, 0,
			  FW_BOLD, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
			  PROOF_QUALITY, FF_DONTCARE, 'Times New Roman');
  hOldFont := FRally.Font.Handle;
  FRally.Font.Handle := hFont;
  DeleteObject(hOldFont);

  { Here's actual component scaling. }
  for i := 0 to ComponentCount - 1 do begin
	if Components[i] is TControl then begin
	  c := TControl(Components[i]);
	  c.Left   := Xs[i] * Longint(ClientWidth) div OW;
	  c.Top	:= Ys[i] * Longint(ClientHeight) div OH;
	  c.Width  := Ws[i] * Longint(ClientWidth) div OW;
	  c.Height := Hs[i] * Longint(ClientHeight) div OH;
	end;
  end;

  for i := 0 to Tempi.ColCount-1 do begin
	   Tempi.ColWidths[i] := Wt[i] * Longint(ClientWidth) div OW;
  end;

  Tempi.DefaultRowHeight := Ht * Longint(ClientHeight) div OH;

  { Roba per debug
  FmtStr(s, 'X=%d Y=%d X''=%d Y''=%d H=%d H''=%d', [OW, OH, ClientWidth, ClientHeight, Ht, Tempi.DefaultRowHeight]);
  FRally.Caption := s;
  }
  for i := 0 to Note.ColCount-1 do begin
	   Note.ColWidths[i] := Wn[i] * Longint(ClientWidth) div OW;
  end;

  Note.DefaultRowHeight := Hn * Longint(ClientHeight) div OH;

  for i := 0 to Stazioni.ColCount-1 do begin
	   Stazioni.ColWidths[i] := Wc[i] * Longint(ClientWidth) div OW;
  end;

  Stazioni.DefaultRowHeight := Hc * Longint(ClientHeight) div OH;

  { Finally save window dimensions }
  PrevWidth  := ClientWidth;
  PrevHeight := ClientHeight;
 end;

{
 Se qualcuno ci tiene proprio a vederlo, mostra l'AbouBox
}
procedure TFRally.InfoClick(Sender: TObject);
begin
	 Application.CreateForm(TAboutBox, AboutBox);
	 AboutBox.Visible := False;
	 AboutBox.Visible := True;
end;

{
 Di gran lunga il metodo pi utile
}
procedure TFRally.Escidalprogramma1Click(Sender: TObject);
begin
	 Application.CreateForm(TFine,Fine);
    Fine.Show;
end;

{
 Gestione scrittura in Txbuf
}
procedure TFRally.TxBufKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);

var buf: array[0..10] of char;
	s: string;

begin
	if (Key > $40) and (Shift = [ssCtrl]) then begin
		buf[0] := chr(Key - $40);
		buf[1] := NULL;
		WriteComm(PortNum, buf, 1);
		Key := 0;
   end;
end;

{
 Gestione men Aiuto->GNU License
}
procedure TFRally.GNUlicClick(Sender: TObject);
begin
	Application.CreateForm(TFGNU, FGNU);
	FGNU.Visible := False;
	FGNU.Visible := True;
end;

{
 Gestione chiusura programma
}
procedure TFRally.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Application.CreateForm(TFine,Fine);
	Fine.Visible := False;
	Fine.Visible := True;
	Action := caNone;
end;

{
 Gestione doppio click sull'elenco delle stazioni connesse
}
procedure TFRally.StazioniClick(Sender: TObject);

var ch: char;
	 buf: array[0..5] of char;

begin
	ch := OmConn[Stazioni.Row].Stream;
	if (TNCType = TNC2_10) or (TNCType = TASCO) then begin
		if ch in ['A'..'J'] then begin
			LastStream := ch;
			LastPS := OmConn[Stazioni.Row].PS;
			LastCall := OmConn[Stazioni.Row].Call;
			buf[0] := '|';
			buf[1] := LastStream;
			buf[2] := BELL;
			buf[3] := CR;
			WriteComm(PortNum,buf,4);
		end;
	end else if (TNCType = TNC2_5) then begin
		if ch in ['A'..'F'] then begin
			LastStream := ch;
			LastPS := OmConn[Stazioni.Row].PS;
			LastCall := OmConn[Stazioni.Row].Call;
			buf[0] := '|';
			buf[1] := LastStream;
			buf[2] := BELL;
			buf[3] := CR;
			WriteComm(PortNum,buf,4);
		end;
	end else begin
		if ch in ['0'..'9'] then begin
			LastStream := ch;
			LastPS := OmConn[Stazioni.Row].PS;
			LastCall := OmConn[Stazioni.Row].Call;
			buf[0] := '|';
			buf[1] := LastStream;
			buf[2] := BELL;
			buf[3] := CR;
			WriteComm(PortNum,buf,4);
		end;
	end;
end;

{
 Gestione men Foglio->Visualizza Foglio...
}
procedure TFRally.SelezionaClick(Sender: TObject);
begin
	FFogli.Show;
end;

{
 Gestione men Aiuto->Manuale in linea
}
procedure TFRally.ManClick(Sender: TObject);
begin
	Application.CreateForm(TFAiuto, Faiuto);
	FAiuto.Visible := False;
	FAiuto.Visible := True;
end;

{
 Gestione pulsante BAggiorna
}
procedure TFRally.BAggiornaClick(Sender: TObject);
begin
	if State = WaitStrSWOrCmd then begin
		State := UpdateConns;
		BAggiorna.Caption := 'Sto aggiornando...';
		WriteComm(PortNum, CTRLC, 1);
		WriteComm(PortNum, CR, 1);
		WriteComm(PortNum, 'cs', 2);
		WriteComm(PortNum, CR, 1);
		WriteComm(PortNum, 'k', 1);
		WriteComm(PortNum, CR, 1);
	end else if State = UpdateConns then begin
		State := WaitStrSWOrCmd;
		BAggiorna.Caption := 'Aggiorna elenco';
   end;
end;

{
 Gestione men File->Apri Quaderno
}
procedure TFRally.Apri1Click(Sender: TObject);

var FName: string;

begin
	FmtStr(FName, '%s.DAT', [NomeFile]);
	ApriFile.Filter := 'File Quaderno|*.DAT';
 	ApriFile.Filename := FName;
	if ApriFile.Execute then begin
		try
			AssignFile(Quaderno,ApriFile.FileName);
			Reset(Quaderno);
		except
       	on EInOutError do begin
       		try
					Rewrite(Quaderno);
				except
               	on EInOutError do begin
		   				Ret := Application.MessageBox('Non riesco ad aprire il file dei fogli ricevuti!',
						'Errore!', MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
						if Ret = IDABORT then Halt;
                   end;
               end;
			end;
		end;
		if FileSize(Quaderno) > 0 then begin
			FFogli.ElencoFogli.Clear;
	 		while not eof(Quaderno) do begin
				Read(Quaderno, Foglio);
				s := Format('PS %2d Foglio %2d', [Foglio.PSNum, Foglio.FoglioNum]);
				FFogli.ElencoFogli.Items.Add(s);
			end;
			FRally.VisualizzaFoglio(Foglio);
		 end else begin
	 	   FFogli.ElencoFogli.Clear;
		   FRally.CancellaDisplay;
		   FillChar(Foglio, SizeOf(Foglio), 0);
	 	end;
    end;
end;

{
 Gestione men File->Apri Log
}
procedure TFRally.AprifileLog1Click(Sender: TObject);

var FName:string;

begin
	FmtStr(FName, '%s.LOG', [NomeFile]);
 	ApriFile.Filename := FName;
   ApriFile.Filter := 'File di log|*.LOG';
	if ApriFile.Execute then begin
		 AssignFile(RawLogFile,ApriFile.FileName);
		 Append(RawLogFile);
   end;
end;

{
 Gestione men Log->Visualizza Log
}
procedure TFRally.Visualizza1Click(Sender: TObject);

var s: string;

begin
		FLog.DispLog.Clear;
		Reset(RawLogFile);
		while not Eof(RawLogFile) do begin
		   ReadLn(RawLogFile,s);
		   FLog.DispLog.Lines.Add(s);
	   	end;
		Append(RawLogFile);
		FLog.Visible := True;
end;

{
 Disconnette la stazione collegata al canale channel
}
procedure TFRally.Disconnect(channel: char);
var ch: char;
	 buf: array[0..5] of char;

begin
	if (TNCType = TNC2_10) or (TNCType = TASCO) then begin
		if channel in ['A'..'J'] then begin
			buf[0] := CTRLC;
			buf[1] := '|';
			buf[2] := channel;
			buf[3] := CR;
			buf[4] := 'd';
			buf[5] := CR;
			WriteComm(PortNum,buf,6);
		end;
	end else if (TNCType = TNC2_5) then begin
		if channel in ['A'..'F'] then begin
			buf[0] := CTRLC;
			buf[1] := '|';
			buf[2] := channel;
			buf[3] := CR;
			buf[4] := 'd';
			buf[5] := CR;
			WriteComm(PortNum,buf,6)
		end;
	end else begin
		if ch in ['0'..'9'] then begin
			buf[0] := CTRLC;
			buf[1] := '|';
			buf[2] := channel;
			buf[3] := CR;
			buf[4] := 'd';
			buf[5] := CR;
			WriteComm(PortNum,buf,5);
		end;
	end;
	buf[0] := 'k';
	buf[1] := CR;
	WriteComm(PortNum,buf,2);
end;

{
 Evidenzia nell'elenco delle stazioni la linea corrispondente allo stream attivo
}
procedure TFRally.EvidenziaStazione(channel: char);

var i: integer;

begin
	for i := 1 to 10 do begin
   	if OmConn[i].Stream = channel then begin
			Stazioni.Row := i;
           break;
       end;
   end;
end;

{
 Invia il messaggio di sconnessione
}
procedure TFRally.ByeBye(channel: char);

var buf: array[0..20] of char;
      t: TDateTime;
    len: integer;

begin
	StrFmt(buf, '|%s73!%s', [channel, CR]);
  	Len := StrLen(buf);
	WriteComm(PortNum, buf, Len);
	t := Time;
	Repeat until (Time-t) > 3/86400;
end;

{
 Gestione popupmen Disconnetti
}
procedure TFRally.DiscClick(Sender: TObject);

var ch: char;

begin
	ch := OmConn[Stazioni.Row].Stream;
	ByeBye(ch);
	Disconnect(ch);
end;

{
 Gestione popupmen Connetti
}
procedure TFRally.ConnClick(Sender: TObject);

var ch,Stream: char;
	 call: string;
	 buf: array[0..20] of char;

begin
	Stream := chr(ord('A') + Stazioni.Row - 1);
	call := Conf.RallyData.CallPS[(Sender as TMenuItem).Tag];
	StrFmt(buf, '%s%s|%sc %s%s', [CTRLC, CR, Stream, call, CR]);
	WriteComm(PortNum,buf,StrLen(buf));
end;

{
 Gestione men File->Anteprima di Stampa
}
procedure TFRally.AnteprimadiStampa1Click(Sender: TObject);
begin
	Preview.Show;
	if Conf.AutoPrintI = 0 then begin
		FRally.StampaFoglio(Foglio, False, True);
   end else begin
		FRally.StampaFoglio(Foglio, True, True);
   end;
end;

{
 Conta il numero di prove speciali contenute in Quaderno
}
function TFRally.ContaPS(var MinPS: integer; var MaxPS: integer): integer;

var Foglio: TFoglio;

begin
	Seek(Quaderno,0);
	MaxPS := 0;
	MinPS := MaxInt;
	while not Eof(Quaderno) do begin
		Read(Quaderno, Foglio);
		if Foglio.PSNum > MaxPS then MaxPS := Foglio.PSNum;
		if Foglio.PSNum < MinPS then MinPS := Foglio.PSNum;
	end;
	ContaPS := MaxPS - MinPS + 1
end;

{
 Ordina la classifica ufficiosa in base ai tempi
}
procedure TFRally.OrdinaClassifica(NumPS: integer);

var n,m: integer;
    ClTemp: TClassifica;
    Swapped: Boolean;

begin
   {
    Copia la classifica in un array temporaneo eliminando i concorrenti
    che non hanno percorso tutte le PS (=ritirati)
   }
	m := 1;
	FillChar(ClassOrd, SizeOf(ClassOrd), 0);
   for n := 1 to MAXCONC do begin
   	if Classifica[n].NumProve = NumPS then begin
       	ClassOrd[m] := Classifica[n];
           m := m + 1;
       end;
   end;

	repeat
      	Swapped := False;
		for n := 1 to m do begin
 			if ClassOrd[n].Tempo > ClassOrd[n+1].Tempo then begin
				Cltemp := ClassOrd[n];
       	    ClassOrd[n] := ClassOrd[n+1];
           	ClassOrd[n+1] := ClTemp;
               Swapped := True;
       	end;
       end;
   until not Swapped;
end;

{
 Gestione del men Classifica->Generale
}
procedure TFRally.Generale1Click(Sender: TObject);

var NumPS, MaxPS, MinPS: integer;

begin
	if FileSize(Quaderno) > 0 then begin
		ContaPS(MinPS, MaxPS);
		RicostruisciClassifica(MaxPS);
		OrdinaClassifica(MaxPS);
   	VisualizzaClassifica('',0);
   end else begin
		Ret := Application.MessageBox('Non c'' nessun foglio!',
				'Errore!', MB_ICONSTOP+MB_OK);
   end;
end;

{
 Gestione del men Classifica->Di Classe
}
procedure TFRally.DiClasse1Click(Sender: TObject);

var NumPS, MaxPS, MinPS: integer;
	 s: string;

begin
	s := (Sender as TMenuItem).Caption;
	if FileSize(Quaderno) > 0 then begin
		ContaPS(MinPS, MaxPS);
		RicostruisciClassifica(MaxPS);
		OrdinaClassifica(MaxPS);
   	VisualizzaClassifica(s,0);
   end else begin
		Ret := Application.MessageBox('Non c'' nessun foglio!',
				'Errore!', MB_ICONSTOP+MB_OK);
   end;
end;

{
 Visualizza la classifica
}
procedure TFRally.VisualizzaClassifica(Classe: string; NumPS: integer);

var n,i,cent,sec,min,ore: integer;
    s: string[80];
    t: longint;

begin
   for n := 1 to 50 do begin
   	FClass.SGClassifica.Cells[0,n] := '';
   	FClass.SGClassifica.Cells[1,n] := '';
		FClass.SGClassifica.Cells[2,n] := '';
       FClass.SGClassifica.Cells[3,n] := '';
   end;
	i := 1;
	for n := 1 to MaxConc do begin
   	if (ClassOrd[n].NumConc > 0) and
          ((CompareText(ClassOrd[n].Classe, Classe) = 0) or
           (Classe = '')) then begin
		   	Str(i:3, s);
  			FClass.SGClassifica.Cells[0,i] := s;
	   		Str(ClassOrd[n].NumConc:3, s);
	  		FClass.SGClassifica.Cells[1,i] := s;
			FClass.SGClassifica.Cells[2,i] := ClassOrd[n].Classe;
			t := ClassOrd[n].Tempo;
			cent := t mod 100;
	  	    t := t div 100;
   	   	sec := t mod 60;
			t := t div 60;
	  	    min := t mod 60;
			t := t div 60;
			ore := t mod 60;
			FmtStr(s, '%2.2dh %2.2d'' %2.2d'''' %2.2d', [ore,min,sec,cent]);
  			FClass.SGClassifica.Cells[3,i] := s;
           i := i + 1;
           if i > 50 then break;
		end;
	end;
   s := Conf.RallyData.NomeRally + ' - Classifica Ufficiosa';
   if Classe <> '' then s := s + ' classe ' + Classe else begin
   	s := s + ' Generale';
   	if NumPS > 0 then s := s + ' sino alla PS ' + IntToStr(NumPs);
   	if NumPS < 0 then s := s + ' della PS ' + IntToStr(abs(NumPS));
   end;
   FClass.Caption := s;
	FClass.Show;
end;

{
 Aggiorna la classifica ufficiosa coi dati contenuti in foglio
}
procedure TFRally.AggiornaClassifica(Foglio: TFoglio);

var t: longint;
	 n,NumConc: integer;

begin
	for n := 1 to Foglio.NumTempi do begin
   	{
        Calcola il tempo espresso in centesimi come long integer
       }
		case Conf.TimeFormatI of
			0: begin
				t := 6000*longint(Foglio.Tempi[n].Tempo.Minuti)  +
				100*longint(Foglio.Tempi[n].Tempo.Secondi);
			end;
			1: begin
				t := 6000*longint(Foglio.Tempi[n].Tempo.Minuti) +
				100*longint(Foglio.Tempi[n].Tempo.Secondi) +
				10*longint(Foglio.Tempi[n].Tempo.Centesimi); { in realt sono decimi }
			end;
			2: begin
				t := 6000*longint(Foglio.Tempi[n].Tempo.Minuti)  +
				100*longint(Foglio.Tempi[n].Tempo.Secondi) +
				longint(Foglio.Tempi[n].Tempo.Centesimi); { sono davvero centesimi }
			end;
		end;
       NumConc := Foglio.Tempi[n].Numero;
       { Il tempo totale  espresso in centesimi di secondo }
       if (NumConc > 0) and (NumConc <= MAXCONC) then begin
       	Classifica[NumConc].NumConc := NumConc;
       	Classifica[NumConc].Tempo := Classifica[NumConc].Tempo + t;
       	Classifica[NumConc].NumProve := Classifica[NumConc].NumProve+1;
       end;
   end;
end;

{
 Gestione del men Classifica->Generale sino alla PS...
}
procedure TFRally.GeneralePSClick(Sender: TObject);

var NumPS,MinPS,MaxPS: integer;

begin
	NumPS := (Sender as TMenuItem).Tag;
	if FileSize(Quaderno) > 0 then begin
		RicostruisciClassifica(NumPS);
		ContaPS(MinPs,MaxPS);
		OrdinaClassifica(NumPS-MinPs+1);
		VisualizzaClassifica('',NumPS);
		RicostruisciClassifica(MaxPS);
   end else begin
		Ret := Application.MessageBox('Non c'' nessun foglio!',
				'Errore!', MB_ICONSTOP+MB_OK);
   end;
end;

{
 Gestione del men Classifica->Di Classe sino alla PS...
}
procedure TFRally.DiClassePSClick(Sender: TObject);

var NumPS,MinPS,MaxPS: integer;

begin
	if FileSize(Quaderno) > 0 then begin
		NumPS := (Sender as TMenuItem).Tag;
       {
        Un numero di PS < 0 significa che si vuole la classifica di quella
        sola PS, uno > 0 che si vuola la classifica sino a quella PS
       }
		RicostruisciClassifica(NumPS);
		ContaPS(MinPs,MaxPS);
		if NumPS > 0 then begin
			OrdinaClassifica(NumPS-MinPs+1);
		end else begin
			OrdinaClassifica(1);
       end;
		VisualizzaClassifica((Sender as TMenuItem).Caption,NumPS);
		RicostruisciClassifica(MaxPS);
   end else begin
		Ret := Application.MessageBox('Non c'' nessun foglio!',
				'Errore!', MB_ICONSTOP+MB_OK);
   end;
end;

{
 Ricostruisce la classifica ufficiosa sino alla PS specificata
 sulla base dei fogli memorizzati
}
procedure TFRally.RicostruisciClassifica(PSNum: integer);

var Foglio: TFoglio;
    n,m,i: integer;
    Presente: Boolean;
    s: string[80];

begin
	for n:=0 to MAXCONC do begin
		Classifica[n].NumProve := 0;
   	Classifica[n].Tempo := 0;
   end;
	Seek(Quaderno, 0);
	while not Eof(Quaderno) do begin
   	Read(Quaderno,Foglio);
       if PSNum > 0 then begin
       	if Foglio.PSNum <= PSNum then AggiornaClassifica(Foglio);
       end else begin
       	if Foglio.PSNum = abs(PSNum) then AggiornaClassifica(Foglio);
       end;
   end;
	CostruisciMenuClasse;
   CostruisciMenuPS;
end;

{
 Gestione del men File->Salva Rally...
}
procedure TFRally.SalvaRally1Click(Sender: TObject);

var FName: string;
    Foglio: TFoglio;

begin
	FmtStr(FName, '%s.RLY', [NomeFile]);
   SaveRally.Filename := FName;
   SaveRally.DefaultExt := 'RLY';
   SaveRally.Filter := 'File Rally|*.RLY';
	if SaveRally.Execute then begin
   	FName := SaveRally.Filename;
       try
       	AssignFile(RallyFile, FName);
       	Rewrite(RallyFile,1);
           BlockWrite(RallyFile, Conf, SizeOf(Conf));
           Seek(Quaderno,0);
           while not Eof(Quaderno) do begin
               Read(Quaderno,Foglio);
	        	BlockWrite(RallyFile, Foglio, SizeOf(Foglio));
           end;
			CloseFile(RallyFile);
       except
       	on EInOutError do begin
  			Ret := Application.MessageBox('Non riesco a salvare il file del rally!',
				'Errore!', MB_ICONSTOP+MB_OK);
           end;
       end;
   end;

end;

procedure TFRally.CostruisciMenuConnetti;

var i: integer;

begin
	{ Cancella i vecchi sottomen del men Connetti }
	for i := 1 to FRally.Conn.Count do begin
		ConnMenu[i].Free;
	end;

	{ Costruisce il sottomen Connetti }
	i := 1;
	while Conf.RallyData.CallPS[i] <> '' do begin
			ConnMenu[i] := TMenuItem.Create(Self);
			ConnMenu[i].Caption := Conf.RallyData.CallPS[i];
			ConnMenu[i].OnClick := ConnClick;
			Connmenu[i].Tag := i;
			Conn.Add(ConnMenu[i]);
			i := i + 1;
	end;
end;

{
 Costruisce il sottomen Di Classe
}
procedure TFRally.CostruisciMenuClasse;

var n,m,i: integer;
    Presente: Boolean;

begin
	{ Cancella i vecchi sottomen del men Di Classe }

	for i := 1 to DiClasse1.Count do begin
		MenuClassi1[i].Free;
		MenuClassi2[i].Free;
	end;
	{ Costruisce il sottomen Di Classe }
	i := 1;
	for n := 1 to MAXCONC do begin
		Presente := False;
  		for m := 1 to i-1 do begin
  		   	if (MenuClassi1[m].Caption = Conf.Classifica[n].Classe) or
      			(Conf.Classifica[n].Classe = '') then begin
   	       	Presente := TRUE;
	    	    break;
	      	end;
		end;
		if not Presente then begin
			MenuClassi1[i] := TMenuItem.Create(Self);
			MenuClassi1[i].Caption := Conf.Classifica[n].Classe;
		    MenuClassi1[i].OnClick := DiClasse1Click;
			MenuClassi1[i].Tag := i;
			DiClasse1.Add(MenuClassi1[i]);
{
			MenuClassi2[i] := TMenuItem.Create(Self);
			MenuClassi2[i].Caption := Conf.Classifica[n].Classe;
		    MenuClassi2[i].OnClick := DiClasse1PSClick;
			MenuClassi2[i].Tag := i;
			DiClassePS.Add(MenuClassi2[i]);
}
           i := i + 1;
		end;
	end;
end;

{
 Costruisce il sotto-sottomen delle PS del sottomen 'di Classe sino alla PS...'
}
procedure TFRally.CostruisciMenuPSMenuClassi;

var NumPS,MinPS,MaxPS,n: integer;

begin
	{ DA SCRIVERE }
end;

{
 Costruisce il sottomen delle PS
}
procedure TFRally.CostruisciMenuPS;

var NumPS,MinPS,MaxPS,n: integer;

begin
	{ Cancella i vecchi sottomen del men delle PS }
	for n := 1 to FRally.GeneralePS.Count do begin
		MenuPS1[n].Free;
       MenuPS2[n].Free;
	end;
	{ Costruisce il sottomen delle PS }
	ContaPS(MinPS, MaxPS);
	for n := MinPS to MaxPS do begin
		MenuPS1[n] := TMenuItem.Create(Self);
       FmtStr(s, 'PS %d', [n]);
		MenuPS1[n].Caption := s;
       MenuPS1[n].OnClick := GeneralePSClick;
		MenuPS1[n].Tag := n;
		GeneralePS.Add(MenuPS1[n]);

		MenuPS2[n] := TMenuItem.Create(Self);
   	MenuPS2[n].Caption := s;
       MenuPS2[n].OnClick := dellaPS1Click;
		MenuPS2[n].Tag := -n;
       dellaPS1.Add(MenuPS2[n]);

	end;
end;

{
 Gestione del men File->Apri Rally...
}
procedure TFRally.ApriRally1Click(Sender: TObject);

var FName: string;
	 RallyFile: File;
    TmpConf: TConf;
    i,NumPS,MinPS,MaxPS: integer;
    s: string;

begin
	FmtStr(FName, '%s.RLY', [NomeFile]);
	ApriFile.Filter := 'File Rally|*.RLY';
   Aprifile.Filename := FName;
   if ApriFile.Execute then begin
		try
		 	AssignFile(RallyFile,ApriFile.FileName);
			Reset(RallyFile,1);
           BlockRead(RallyFile, TmpConf, SizeOf(TmpConf));
			RallyData := TmpConf.RallyData;
			Conf.RallyData := TmpConf.RallyData;
           NewSheetI := TmpConf.NewSheetI;
           Conf.NewSheetI := TmpConf.NewSheetI;
           TimeFormatI := TmpConf.TimeFormatI;
           Conf.TimeFormatI := TmpConf.TimeFormatI;
           AutoPrintI := TmpConf.AutoPrintI;
           Conf.AutoPrintI := TmpConf.AutoPrintI;
   	    Move(TmpConf.Classifica, Conf.Classifica, SizeOf(TmpConf.Classifica));
   	    Move( TmpConf.Classifica, Classifica, SizeOf(TmpConf.Classifica));
			for i := 1 to MAXCONC do begin
				Str(i:3, s);
				ConfForm.SGClassi.Cells[0,i] := s;
				ConfForm.SGClassi.Cells[1,i] := Classifica[i].Classe;
			end;
	   		NomeFile := ExtractFileName(ApriFile.FileName);
   	    i := Pos('.',NomeFile);
			if i > 0 then Delete(NomeFile, i, 10);
			FmtStr(FName, '%s.DAT', [NomeFile]);
			CloseFile(Quaderno);
           AssignFile(Quaderno,FName);
			Rewrite(Quaderno);

			FillChar(Foglio, SizeOf(Foglio), 0);
           while not Eof(RallyFile) do begin
           	BlockRead(RallyFile, Foglio, SizeOf(Foglio));
               Write(Quaderno, Foglio);
           end;
           CloseFile(RallyFile);
	    except
       	on EInOutError do begin
	  			Ret := Application.MessageBox('Non riesco ad aprire il file del rally!',
				'Errore!', MB_ICONSTOP+MB_OK);
           end;
   	end;

		try
			FmtStr(FName, '%s.LOG', [NomeFile]);
  			CloseFile(RawLogFile);
           AssignFile(RawLogFile,FName);
			Append(RawLogFile);
       except
   		on EInOutError do begin
		       	try
       	    	Rewrite(RawLogFile);
           	except
                   On EInOutError do begin
						Application.MessageBox('Non riesco ad aprire il file di log!',
							'Errore!', MB_ICONSTOP+MB_OK);
                   end;
               end;
           end;
       end;
      FFogli.AggiornaLista;
      NumPs := ContaPS(MinPS, MaxPS);
	   RicostruisciClassifica(MaxPS);
      OrdinaClassifica(NumPS);
	   CostruisciMenuClasse;
      CostruisciMenuPS;
      CancellaDisplay;
      if FileSize(Quaderno) > 0 then VisualizzaFoglio(Foglio);
	   FRally.Caption := 'FreeWinRally '+ PrgVers + ' - ' + Conf.RallyData.NomeRally;
  end;
end;

{
 Gestione del men Classifica->Azzera
}
procedure TFRally.Azzera1Click(Sender: TObject);

var n: integer;

begin
	for n := 0 to MAXCONC do begin
      	Classifica[n].NumProve := 0;
      	Classifica[n].Tempo := 0;
	end;

	{ Cancella i vecchi sottomen del men Di Classe
	for n := 1 to DiClasse1.Count do begin
		MenuClassi1[n].Free;
		MenuClassi2[n].Free;
   end;
   }
end;

{
 Gestione del men File->Nuovo Rally...
}
procedure TFRally.NuovoRally1Click(Sender: TObject);

var i: integer;
    FName: string;

begin

   { Chiede il nome del nuovo file }
{
	FmtStr(FName, '%s.RLY', [NomeFile]);
  	ApriFile.Filename := FName;
}
  	ApriFile.Filename := 'Nuovo.RLY';
  	ApriFile.Filter := 'File Rally|*.RLY';
   if ApriFile.Execute then begin
       NomeFile := ExtractFileName(ApriFile.FileName);
       i := Pos('.',NomeFile);
       if i > 0 then Delete(NomeFile, i, 10);

		{ Cancella i vecchi sottomen del men Connetti }
		for i := 1 to FRally.Conn.Count do begin
			ConnMenu[i].Free;
		end;

		{ Cancella i vecchi sottomen del men Di Classe }
		for i := 1 to FRally.DiClasse1.Count do begin
			MenuClassi1[i].Free;
		end;

		{ Cancella i vecchi sottomen dei men Generale/Di Classe sino alla PS... }
		for i := 1 to GeneralePS.Count do begin
			MenuPS1[i].Free;
           MenuPS2[i].Free;       ;
		end;

		{ Cancella l'elenco dei fogli }
		FFogli.ElencoFogli.Clear;

       { Cancella le classifiche }
       FillChar(Classifica, SizeOf(Classifica), 0);
       FillChar(ClassOrd, SizeOf(ClassOrd), 0);

		{ Cancella il display }
       CancellaDisplay;

       { Resetta il colore del numero del foglio
       Label2.Color := clAqua;
       LFGnum.Color := clAqua;                  }

		{ Cancella l'elenco degli Om agli stop e le lunghezze delle PS }
		for i := 1 to 50 do begin
       	OmConn[i].PS := 0;
           OmConn[i].Stream := chr(0);
           OmConn[i].Call := '';
       	Conf.RallyData.CallPS[i] := '';
           Conf.RallyData.CallPS[i] := chr(0);
           Conf.RallyData.CallPS[i] := '';
        	Conf.RallyData.KmPS[i] := 0;
           ConfForm.KmPS.Cells[1,i] := '';
           ConfForm.ListaOm.Cells[1,i] := '';
       end;

		{ Riporta tutte le scritte al default iniziale }
		with Conf.RallyData do begin
			NomeRally := '<Nome del Rally>';
			MyCall := 'NOCALL';
			TxDatiBy := 'delle Sezioni ARI di Asti e di Casale Monferrato';
			DescrRally[1] := '<Descrizione del rally (riga 1)>';
			DescrRally[2] := '<Descrizione del rally (riga 2)>';
			InfoRally[1] := '<Testo generico (riga 1)>';
			InfoRally[2] := '<Testo generico (riga 2)>';
       end;
      	FRally.Caption := 'FreeWinRally '+ PrgVers + ' - ' + Conf.RallyData.NomeRally;

   	{ Chiude tutti i file }
		Closefile(Quaderno);
   	Closefile(RawLogFile);

		{ Riparte dal giro n. 1 }
       NGiro := 1;

		FmtStr(FName, '%s.DAT', [NomeFile]);
		try
			AssignFile(Quaderno, FName);
			Rewrite(Quaderno);
		except
	  		on EInOutError do begin
				Ret := Application.MessageBox('Non riesco ad aprire il file dei fogli!',
					'Errore!', MB_ICONSTOP+MB_OK);
			end;
		end;

		FmtStr(FName, '%s.LOG', [NomeFile]);
		try
			AssignFile(RawLogFile, FName);
		   	Rewrite(RawLogFile);
		except
			on EInOutError do begin
				Ret := Application.MessageBox('Non riesco ad aprire il file di log',
					'Errore!', MB_ICONSTOP+MB_OK);
			end;
   	end;
  	end;
end;

procedure TFRally.dellaps1click(Sender: TObject);

var NumPS,MinPS,MaxPS: integer;

begin
	NumPS := (Sender as TMenuItem).Tag;
	if FileSize(Quaderno) > 0 then begin
       {
        Un numero di PS < o significa che si vuole la classifica di quella
        sola PS, uno > 0 che si vuola la classifica sino a quella PS
       }
		RicostruisciClassifica(NumPS);
		ContaPS(MinPs,MaxPS);
		if NumPS > 0 then begin
			OrdinaClassifica(NumPS-MinPs+1);
		end else begin
			OrdinaClassifica(1);
       end;
		VisualizzaClassifica('',NumPS);
		RicostruisciClassifica(MaxPS);
   end else begin
		Ret := Application.MessageBox('Non c'' nessun foglio!',
				'Errore!', MB_ICONSTOP+MB_OK);
   end;

end;


procedure TFRally.InviaFoglioAiCrono(Foglio: TFoglio);

var n,nc,err,Centesimi,Checksum: integer;
	 s: String;
    buf: array[0..128] of char;

begin
	NumTappa := ConfForm.Tappa.Value;
   if (Foglio.PSNum > 0 ) and (Foglio.FoglioNum > 0) then begin
		for n := 1 to Foglio.NumTempi do begin
           Centesimi := 0;
       	if Conf.TimeFormatI = 1 then Centesimi := 10*Foglio.Tempi[n].Tempo.Centesimi;
           if Conf.TimeFormatI = 2 then Centesimi := Foglio.Tempi[n].Tempo.Centesimi;
			FmtStr(s, CronoFmt,
           [SOH,
            NumTappa,
            Foglio.PSNum,
            Foglio.FoglioNum,
            Foglio.Tempi[n].Numero,
            0,							{ Ore fisse a zero }
            Foglio.Tempi[n].Tempo.Minuti,
            Foglio.Tempi[n].Tempo.Secondi,
            Centesimi
           ]);
           Checksum := 0;
			for nc := 1 to Length(s) do Checksum := Checksum + ord(s[nc]);
	        StrFmt(buf, '%s%4.4d%s',[s, Checksum, CR]);
   	    WriteComm(CronoPortNum, buf, StrLen(buf));
		end;
	end;
end;


procedure TFRally.InviaAiCronoClick(Sender: TObject);
begin
	if CronoPortNameI >= 0 then begin
  		InviaFoglioAiCrono(Foglio);
   end;
end;

{
 Inizializzazioni varie
}
procedure TFRally.Aggiornaelencofogli1Click(Sender: TObject);
begin
	FFogli.AggiornaLista;
end;

Initialization

{
 Mostra una finestra che chiede di pazientare durante l'inizializzazione
 del programma (che dura piuttosto a lungo). La si deve creare a mano
 perch a questo punto non  ancora stato creato nessun form.
}
	Startup := TStartup.Create(FRally);
	Application.ProcessMessages;

	PortNum := -1;
   CronoPortNum := -1;

	{ I nomi dei mesi in italiano }
	LongMonthNames[1] := 'Gennaio';
	LongMonthNames[2] := 'Febbraio';
	LongMonthNames[3] := 'Marzo';
	LongMonthNames[4] := 'Aprile';
	LongMonthNames[5] := 'Maggio';
	LongMonthNames[6] := 'Giugno';
	LongMonthNames[7] := 'Luglio';
	LongMonthNames[8] := 'Agosto';
	LongMonthNames[9] := 'Settembre';
	LongMonthNames[10] := 'Ottobre';
	LongMonthNames[11] := 'Novembre';
	LongMonthNames[12] := 'Dicembre';

	{ I nomi dei giorni in italiano }
	LongDayNames[1] := 'Domenica';
	LongDayNames[2] := 'Luned';
	LongDayNames[3] := 'Marted';
	LongDayNames[4] := 'Mercoled';
	LongDayNames[5] := 'Gioved';
	LongDayNames[6] := 'Venerd';
	LongDayNames[7] := 'Sabato';

	{ I comandi di inizializzazione dei TNC }
	TNCInitCmds[TASCO,1] := 'MONITOR OFF';
	TNCInitCmds[TASCO,2] := 'ECHO OFF';
	TNCInitCmds[TASCO,3] := 'AUTOLF OFF';
	TNCInitCmds[TASCO,4] := 'STREAMSW $7C';
	TNCInitCmds[TASCO,5] := 'STREAMCA ON';
	TNCInitCmds[TASCO,6] := 'BBSMSG ON';
	TNCInitCmds[TASCO,7] := 'USERS 6';
	TNCInitCmds[TASCO,8] := 'FLOW OFF';
	TNCInitCmds[TASCO,9] := 'XFLOW OFF';
	TNCInitCmds[TASCO,10] := 'SENDPAC $0D';
	TNCInitCmds[TASCO,11] := 'RESTART';
	TNCInitCmds[TASCO,12] := '';

	TNCInitCmds[TNC2_5,1] := 'MONITOR OFF';
	TNCInitCmds[TNC2_5,2] := 'ECHO OFF';
	TNCInitCmds[TNC2_5,3] := 'AUTOLF OFF';
	TNCInitCmds[TNC2_5,4] := 'STREAMSW $7C';
	TNCInitCmds[TNC2_5,5] := 'STREAMCA ON';
	TNCInitCmds[TNC2_5,6] := 'BBSMSG ON';
	TNCInitCmds[TNC2_5,7] := 'USERS 5';
	TNCInitCmds[TNC2_5,8] := 'FLOW OFF';
	TNCInitCmds[TNC2_5,9] := 'XFLOW OFF';
	TNCInitCmds[TNC2_5,10] := 'SENDPAC $0D';
	TNCInitCmds[TNC2_5,11] := 'AWLEN 8';
	TNCInitCmds[TNC2_5,12] := 'PARITY 0';
	TNCInitCmds[TNC2_5,13] := 'RESTART';
	TNCInitCmds[TNC2_5,14] := '';

	TNCInitCmds[TNC2_10,1] := 'MONITOR OFF';
	TNCInitCmds[TNC2_10,2] := 'ECHO OFF';
	TNCInitCmds[TNC2_10,3] := 'AUTOLF OFF';
	TNCInitCmds[TNC2_10,4] := 'STREAMSW $7C';
	TNCInitCmds[TNC2_10,5] := 'STREAMCA ON';
	TNCInitCmds[TNC2_10,6] := 'BBSMSG ON';
	TNCInitCmds[TNC2_10,7] := 'USERS 6';
	TNCInitCmds[TNC2_10,8] := 'FLOW OFF';
	TNCInitCmds[TNC2_10,9] := 'XFLOW OFF';
	TNCInitCmds[TNC2_10,10] := 'SENDPAC $0D';
	TNCInitCmds[TNC2_10,11] := 'AWLEN 8';
	TNCInitCmds[TNC2_10,12] := 'PARITY 0';
	TNCInitCmds[TNC2_10,13] := 'RESTART';
	TNCInitCmds[TNC2_10,14] := '';

	TNCInitCmds[PK232,1] := 'PACKET';
	TNCInitCmds[PK232,2] := 'MONITOR OFF';;
	TNCInitCmds[PK232,3] := 'ECHO OFF';
	TNCInitCmds[PK232,4] := 'ALFDISP OFF';
	TNCInitCmds[PK232,5] := 'CHSWITCH $7C';
	TNCInitCmds[PK232,6] := 'CHCALL ON';
	TNCInitCmds[PK232,7] := 'BBSMSG ON';
	TNCInitCmds[PK232,8] := 'USERS 6';
	TNCInitCmds[PK232,9] := 'FLOW OFF';
	TNCInitCmds[PK232,10] := 'XFLOW OFF';
	TNCInitCmds[PK232,11] := 'SENDPAC $0D';
	TNCInitCmds[PK232,12] := 'AWLEN 8';
	TNCInitCmds[PK232,13] := 'PARITY 0';
	TNCInitCmds[PK232,14] := 'RESTART';
	TNCInitCmds[PK232,15] := '';

	{
    Determina quali porte seriali sono disponibili sul sistema
	}
	COMName := StrAlloc(5);
	for n:=1 to 9 do begin
   	StrFmt(COMName, 'COM%d', [n]);
       ComP := OpenComm(COMName, 512, 512);
   	if ComP >= 0 then begin
           COMAvailable[n] := StrPas(COMName);
           CloseComm(ComP);
       end else begin
			COMAvailable[n] := '';
       end;
   end;
   StrDispose(COMName);

	{
    Azzera la classifica
   }
   FillChar(Classifica, SizeOf(Classifica), 0);
	{
	  Apertura del file di configurazione.
	  Se esiste lo si legge, altrimenti si assumono i default
	}

	try
		AssignFile(ConfFile,'WINRALLY.CNF');
		Reset(ConfFile);
		Read(ConfFile, Conf);
		CloseFile(ConfFile);
		RallyData	:= Conf.RallyData;
		PortNameI   := Conf.PortNameI;
       CronoPortNameI := Conf.CronoPortNameI;
		PortSpeedI  := Conf.PortSpeedI;
		PortParityI := Conf.PortParityI;
		PortBitsI   := Conf.PortBitsI;
		PortStopsI  := Conf.PortStopsI;
		PortHandI   := Conf.PortHandI;
		TNCTypeI    := Conf.TncTypeI;
		TNCType     := TNCTypeI;
		NCopie      := Conf.NumCopiesI;
		PrintDPII	:= Conf.PrintDPII;
       Move(Conf.Classifica, Classifica, SizeOf(Classifica));

		if PortName = nil then PortName := StrAlloc(5);
	  	StrFmt(PortName, 'COM%d', [PortNameI]);
		if CronoPortName = nil then CronoPortName := StrAlloc(5);
	  	StrFmt(CronoPortName, 'COM%d', [CronoPortNameI]);

		case PortParityI of
			0: PortParity := ',N';
			1: PortParity := ',O';
			2: Portparity := ',E';
		end;
		case PortSpeedI of
			0: PortSpeed := ',1200';
			1: PortSpeed := ',2400';
			2: PortSpeed := ',4800';
			3: PortSpeed := ',9600';
			4: PortSpeed := ',19200';
			5: PortSpeed := ',38400';
			6: PortSpeed := ',57600';
			7: PortSpeed := ',115200';
			else PortSpeed := ',9600';
		end;
		case PortBitsI of
	 		0: PortBits := ',7';
			1: PortBits := ',8';
		end;
		case PortStopsI of
		 	0: PortStops := ',1';
			1: PortStops := ',2';
		end;
		FontT1.Name  := Conf.SheetFonts.Font1.Name;
		FontT1.Color := Conf.SheetFonts.Font1.Color;
		FontT1.Size  := Conf.SheetFonts.Font1.Size;
		FontT1.Style := Conf.SheetFonts.Font1.Style;

		FontT2.Name  := Conf.SheetFonts.Font2.Name;
		FontT2.Color := Conf.SheetFonts.Font2.Color;
		FontT2.Size  := Conf.SheetFonts.Font2.Size;
		FontT2.Style := Conf.SheetFonts.Font2.Style;

		FontT3.Name  := Conf.SheetFonts.Font3.Name;
		FontT3.Color := Conf.SheetFonts.Font3.Color;
		FontT3.Size  := Conf.SheetFonts.Font3.Size;
		FontT3.Style := Conf.SheetFonts.Font3.Style;

		FontT4.Name  := Conf.SheetFonts.Font4.Name;
		FontT4.Color := Conf.SheetFonts.Font4.Color;
		FontT4.Size  := Conf.SheetFonts.Font4.Size;
		FontT4.Style := Conf.SheetFonts.Font4.Style;

		FontT5.Name  := Conf.SheetFonts.Font5.Name;
		FontT5.Color := Conf.SheetFonts.Font5.Color;
		FontT5.Size  := Conf.SheetFonts.Font5.Size;
		FontT5.Style := Conf.SheetFonts.Font5.Style;

		FontT6.Name  := Conf.SheetFonts.Font6.Name;
		FontT6.Color := Conf.SheetFonts.Font6.Color;
		FontT6.Size  := Conf.SheetFonts.Font6.Size;
		FontT6.Style := Conf.SheetFonts.Font6.Style;

		FontT7.Name  := Conf.SheetFonts.Font7.Name;
		FontT7.Color := Conf.SheetFonts.Font7.Color;
		FontT7.Size  := Conf.SheetFonts.Font7.Size;
		FontT7.Style := Conf.SheetFonts.Font7.Style;

		FontT8.Name  := Conf.SheetFonts.Font8.Name;
		FontT8.Color := Conf.SheetFonts.Font8.Color;
		FontT8.Size  := Conf.SheetFonts.Font8.Size;
		FontT8.Style := Conf.SheetFonts.Font8.Style;
	except
   	on EInOutError do begin
			{ Configurazione inesistente o illeggibile, assumi i default }
			PortName := 'COM1';
           PortNameI := 1;
           CronoPortName := '';
           CronoPortNameI := -1;
           SendCrono := FALSE;
			PortSpeed := ',9600';
			PortParity := ',N';
			PortBits := ',8';
			PortStops := ',1';
			PortHand := 0;
			TNCType := TASCO;
			NCopie := 2;
			PrintDPII := 300;

			with Conf do begin
				PortNameI := 1;
				PortSpeedI := 3;
				PortParityI := 0;
				PortBitsI := 2;
				PortHandI := 0;
				PortStopsI := 0;
				TNCTypeI := 0;
				NewSheetI := 3;
				NumCopiesI := 2;
				PrintDPII := 300;
				RallyData.NomeRally := '<Nome del Rally>';
				RallyData.MyCall := 'NOCALL';
				RallyData.TxDatiBy := 'delle Sezioni ARI di Asti e di Casale Monferrato';
				RallyData.DescrRally[1] := '<Descrizione del rally (riga 1)>';
				RallyData.DescrRally[2] := '<Descrizione del rally (riga 2)>';
				RallyData.InfoRally[1] := '<Testo generico (riga 1)>';
				RallyData.InfoRally[2] := '<Testo generico (riga 2)>';

				SheetFonts.Font1.Name  := 'Times New Roman';
				SheetFonts.Font1.Color := clBlack;
				SheetFonts.Font1.Size  := 24;
				SheetFonts.Font1.Style := [fsBold];
				FontT1.Name  := DefaultFont;
				FontT1.Color := clBlack;
				FontT1.Size  := 24;
				FontT1.Style := [fsBold];

				SheetFonts.Font2.Name  := DefaultFont;
				SheetFonts.Font2.Color := clBlack;
				SheetFonts.Font2.Size  := 20;
				SheetFonts.Font2.Style := [fsBold];
				FontT2.Name  := DefaultFont;
				FontT2.Color := clBlack;
				FontT2.Size  := 20;
				FontT2.Style := [fsBold];

				SheetFonts.Font3.Name  := DefaultFont;
				SheetFonts.Font3.Color := clBlack;
				SheetFonts.Font3.Size  := 16;
				SheetFonts.Font3.Style := [];
				FontT3.Name  := DefaultFont;
				FontT3.Color := clBlack;
				FontT3.Size  := 16;
				FontT3.Style := [];

				SheetFonts.Font4.Name  := DefaultFont;
				SheetFonts.Font4.Color := clBlack;
				SheetFonts.Font4.Size  := 20;
				SheetFonts.Font4.Style := [fsBold];
				FontT4.Name  := DefaultFont;
				FontT4.Color := clBlack;
				FontT4.Size  := 20;
				FontT4.Style := [fsBold];

				SheetFonts.Font5.Name  := DefaultFont;
				SheetFonts.Font5.Color := clBlack;
				SheetFonts.Font5.Size  := 18;
				SheetFonts.Font5.Style := [];
				FontT5.Name  := DefaultFont;
				FontT5.Color := clBlack;
				FontT5.Size  := 18;
				FontT5.Style := [];

				SheetFonts.Font6.Name  := DefaultFont;
				SheetFonts.Font6.Color := clBlack;
				SheetFonts.Font6.Size  := 10;
				SheetFonts.Font6.Style := [fsItalic];
				FontT6.Name  := DefaultFont;
				FontT6.Color := clBlack;
				FontT6.Size  := 10;
				FontT6.Style := [fsItalic];

				SheetFonts.Font7.Name  := DefaultFont;
				SheetFonts.Font7.Color := clBlack;
				SheetFonts.Font7.Size  := 8;
				SheetFonts.Font7.Style := [fsItalic];
				FontT7.Name  := DefaultFont;
				FontT7.Color := clBlack;
				FontT7.Size  := 8;
				FontT7.Style := [fsItalic];

				SheetFonts.Font8.Name  := DefaultFont;
				SheetFonts.Font8.Color := clBlack;
				SheetFonts.Font8.Size  := 6;
				SheetFonts.Font8.Style := [fsItalic];
				FontT8.Name  := DefaultFont;
				FontT8.Color := clBlack;
				FontT8.Size  := 6;
				FontT8.Style := [fsItalic];
           end;
		end;
	end;
	State := WaitStrSwOrCmd;
	if (TNCType = TNC2_5) or(TNCType = TNC2_10) or (TNCType = TASCO) then
		 LastStream := 'A'
	else
		 LastStream := '0';
	LastCall := '';
	LastPS := 1;
	Row := 1;
	tim := 0;
   NGiro := 1;

   { Costruisce il nomefile di default }
	FmtStr(NomeFile, 'RLLY%s', [FormatDateTime('ddmm',Now)]);

	{
	 Apertura del file di log in formato RAW.
	 Si tratta di un file di testo dove viene registrato
	 tutto il traffico, cos come ricevuto o trasmesso.
	 Se esiste gi, lo apre e appende alla fine del file esistente,
	 altrimenti lo crea ex novo.
	}
	FmtStr(s, '%s.LOG', [NomeFile]);

	try
		AssignFile(RawLogFile,s);
   	Append(RawLogFile);
	except
       On EInOutError do begin
		   	try
				Rewrite(RawLogFile);
				FmtStr(s, '--- File di log generato da FreeWinRally in data %s',
   	 			[FormatDateTime('dddddd tt', Now)]);
		 		WriteLn(RawLogFile, s);
			except
				on EInOutError do begin
					Ret := Application.MessageBox('Non riesco ad aprire il file di log!',
						'Errore!', MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
					if Ret = IDABORT then Halt;
               end;
           end;
		end;
	end;

	{
	 Apertura del file dei fogli ricevuti.
	 Si tratta di un file di oggetti TFoglio.
	 Se esiste gi, lo apre e lo utilizza scrivendo i nuovi fogli
	 nel file esistente, altrimenti lo crea ex novo.
	}

	FmtStr(s, '%s.DAT', [NomeFile]);
	try
		AssignFile(Quaderno,s);
		Reset(Quaderno);
	except
   	on EInOutError do begin
			try
				Rewrite(Quaderno);
			except
           	on EInOutError do begin
					Ret := Application.MessageBox('Non riesco ad aprire il file dei fogli ricevuti!',
						'Errore!', MB_ABORTRETRYIGNORE+MB_ICONSTOP+MB_DEFBUTTON1);
					if Ret = IDABORT then Halt;
               end;
           end;
       end;
	end;

   {
 	 Inizializzazione terminata, rimuovi la finestra di startup
	}
	Startup.Release;
end.

